#include "robot.h"
#include "i2cServos.h"
#include "motor.h"
#include <termios.h>
#include <stdio.h>

struct termios confterm;

int main()
{
  char rep;
  
  shared_initModule(); 
  i2c_initModule();

/*passage en mode raw*/
  tcgetattr(0,&confterm);
  confterm.c_lflag = confterm.c_lflag & ~ICANON;
  confterm.c_cc[VMIN]=1;
  tcsetattr(0,TCSANOW,&confterm);

  while (1)
    {
      printf("\n");
      printf("***************************************************************************\n");
      printf("1 -> motor 0 off\n");
      printf("2 -> motor 0 on sens 1\n");
      printf("3 -> motor 0 on sens 2\n");
      printf("4 -> motor 1 off\n");
      printf("5 -> motor 1 on sens 1\n");
      printf("6 -> motor 1 on sens 2\n");
      printf("***************************************************************************\n");
      read(0,&rep,1);
      switch (rep)
	{
	case 'q' :
	  {
	    return 0;
	    break;
	  }
	case '1' :
	  {
	    motorOff(0);
	    break;
	  }
	case '2' :
	  {
	    motorOn(0, MOTOR_SENS_1 );
	    break;
	  }
	case '3' :
	  {
	    motorOn(0, MOTOR_SENS_2);
	    break;
	  }
	case '4' :
	  {
	    motorOff(1);
	    break;
	  }
	case '5' :
	  {
	    motorOn(1, MOTOR_SENS_1);
	    break;
	  }
	case '6' :
	  {
	    motorOn(1, MOTOR_SENS_2);
	    break;
	  }
	}
	
    }
  return 0;
}
