#include "robot.h"
#include "i2cServos.h"
#include <termios.h>
#include <stdio.h>
int currentServo = 0;

int servoPos[4];

struct termios confterm;

int main()
{
  char rep;
  
  shared_initModule(); 
  i2c_initModule();

/*passage en mode raw*/
  tcgetattr(0,&confterm);
  confterm.c_lflag = confterm.c_lflag & ~ICANON;
  confterm.c_cc[VMIN]=1;
  tcsetattr(0,TCSANOW,&confterm);

  servoPos[0]=0;
  servoPos[1]=0;
  servoPos[2]=0;
  servoPos[3]=0;


  while (1)
    {
      printf("\n");
      printf("***************************************************************************\n");
      printf("ID %d - position : %d\n", currentServo, servoPos[currentServo]);
      printf("***************************************************************************\n");
      printf("   - : decrement pos       + : increment pos     [0-7] : change servo ID     q : quit\n");
      read(0,&rep,1);
      switch (rep)
	{
	case 'q' :
	  {
	    return 0;
	    break;
	  }
	case '0' :
	case '1' :
	case '2' :
	case '3' :
	  {
	    currentServo = atoi(&rep);
	    break;
	  }
	case '+' :
	  {
	    setServoPos(currentServo,++servoPos[currentServo]);
	    break;
	  }
	case '-' :
	  {
	    setServoPos(currentServo,--servoPos[currentServo]);
	    break;
	  }
	  
	}
    }
  return 0;
}
