#include "robot.h"

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

int main()
{
  MovementDescriptor* moveToBigStar;
  Event endMoveToBigStarEvent;

  MovementDescriptor* rotationRealign;
  Event endRotationRealignEvent;
 
  MovementDescriptor* rotationLeft;
  Event endRotationLeftEvent;

  MovementDescriptor* rotationRight;
  Event endRotationRightEvent;

  MovementDescriptor* moveBack;
  Event endMoveBackEvent;
  

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");

  shared_initModule();

  i2c_initModule();

  INIThctl();

  move_initModule();
  
  electro_initModule();

  relay_initModule();

  printf("BEGIN of SCENARIO\n");

  //  globalState->ServosCons[0]=0;
  //globalState->ServosCons[1]=29;
  //globalState->ServosCons[2]=234;

  // move moveToBigStar

  createEvent(&endMoveToBigStarEvent,"END_MOVE_TO_BIG_STAR_EVENT");

  moveToBigStar = defineXYMovement(1350.0,0.0);
  setPIDParams(moveToBigStar, 0.5);
//  setMaxSpeed(moveToBigStar, 90, 90, MAX_SPEED_PROPORTIONAL);
  setRefPoint(moveToBigStar, 100.0, 0.0);
  setEndMoveEvent(moveToBigStar,  &endMoveToBigStarEvent);


  moveBack = defineXYMovement(350.0,0.0);
  setPIDParams(moveBack, 0.2);//0.2
  setRefPoint(moveBack, 200.0, 0.0);
  setEndMoveEvent(moveBack,  &endMoveBackEvent);

  // move rotationRealign
  //createEvent(&endRotationRealignEvent,"END_ROTATION_REALIGN_EVENT");

  //rotationRealign= defineRotationMovement(0.0);
  //setEndMoveEvent(rotationRealign,  &endRotationRealignEvent);

  
  // rotation left
  //  createEvent(&endRotationLeftEvent,"END_ROTATION_LEFT_EVENT");

  //rotationLeft = defineRotationMovement(1.0);
  //setEndMoveEvent(rotationLeft,&endRotationLeftEvent);

  // rotation right
  //createEvent(&endRotationRightEvent,"END_ROTATION_RIGHT_EVENT");

  //rotationRight = defineRotationMovement(2.0);
  //setEndMoveEvent(rotationRight,&endRotationRightEvent);

  debug_printf(DEBUG_MODULE_NAME,"WAIT...\n");
  sleep(2);

  ///////////// AVANCE ETOILE
  startMove(moveToBigStar);

  // servos  bras
  globalState->ServosCons[0]=240;

  //  armMotor(ON);
  
  waitEvent(&endMoveToBigStarEvent);
  debug_printf(DEBUG_MODULE_NAME,"End linear movement...\n");

  electroOn(7);

  usleep(500000); 

  startMove(moveBack);
  waitEvent(&endMoveBackEvent);



#if 0
  electroOn(1);
   
  sleep(1); 


  //////////////// REALIGN
  debug_printf(DEBUG_MODULE_NAME,"Realign...\n");
  startMove(rotationRealign);

  armMotor(OFF);

  // servos bras
  globalState->ServosCons[0]=0;

  waitEvent(&endRotationRealignEvent);
  debug_printf(DEBUG_MODULE_NAME,"End realign movement...\n");


  debug_printf(DEBUG_MODULE_NAME,"Rotation left...\n");
  startMove(rotationLeft);
  waitEvent(&endRotationLeftEvent);
  debug_printf(DEBUG_MODULE_NAME,"End rotation left...\n");

#endif  

  sleep(60); 

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");
//  while (1) { sleep(1); }

}



