#include "robot.h"
#include "periodServer.h"

#include <unistd.h>

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#include "move.h"

#define PI 3.14159

int main()
{
  MovementDescriptor* rotation1;
  Event endRotation1Event;

  MovementDescriptor* rotation2;
  Event endRotation2Event;

  MovementDescriptor* rotation3;
  Event endRotation3Event;

  MovementDescriptor* rotation4;
  Event endRotation4Event;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");

  shared_initModule();

  i2c_initModule();

  INIThctl();

  move_initModule();
  
  electro_initModule();

  relay_initModule();

  perServer_initModule();

  debug_printf(DEBUG_MODULE_NAME,"BEGIN of SCENARIO\n");

  // Rotation 1 +PI/2
  //**************************************
  rotation1 = defineRotationMovement(PI);
  createEvent(&endRotation1Event,"END_ROTATION_1_EVENT");
  setEndMoveEvent(rotation1,  &endRotation1Event);
  setMaxSpeed(rotation1,10.0,10.0,MAX_SPEED_PROPORTIONAL);
  startMove(rotation1);
  waitEvent(&endRotation1Event);

  return;

  // Rotation 2 -PI/2
  //**************************************
  rotation2 = defineRotationMovement(-PI/2);
  createEvent(&endRotation2Event,"END_ROTATION_2_EVENT");
  setEndMoveEvent(rotation2,  &endRotation2Event);
  startMove(rotation2);
  waitEvent(&endRotation2Event);

  // Rotation 3 0
  //**************************************
  rotation3 = defineRotationMovement(0.0);
  createEvent(&endRotation3Event,"END_ROTATION_3_EVENT");
  setEndMoveEvent(rotation3,  &endRotation3Event);
  startMove(rotation3);
  waitEvent(&endRotation3Event);

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");

  // Rotation 3 -PI/6
  //**************************************
  rotation4 = defineRotationMovement(-PI/6);
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");


  // Rotation 3 0
  //**************************************
  rotation4 = defineRotationMovement(0.0);
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");



  // Rotation 3 PI-(PI/12)
  //**************************************
  rotation4 = defineRotationMovement(PI-(PI/12));
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);

  // Rotation 3 PI-(PI/12)
  //**************************************
  rotation4 = defineRotationMovement(0.0);
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);

  // Rotation 3 PI-(PI/12)
  //**************************************
  rotation4 = defineRotationMovement(PI+(PI/2));
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);
 
// Rotation 3 PI-(PI/12)
  //**************************************
  rotation4 = defineRotationMovement(0.0);
  createEvent(&endRotation4Event,"END_ROTATION_4_EVENT");
  setEndMoveEvent(rotation4,  &endRotation4Event);
  startMove(rotation4);
  waitEvent(&endRotation4Event);

   debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");

  return 0;
}




