#include "robot.h"
#include "spline.h"

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#define RELAY_MOTOR 1
#define RELAY_BASCULE 2
#define RELAY_CROCHET 0

unsigned char thetaSup(double x, double y, double theta, void* params)
{
  double thetaRef = *((double*)params);
  debug_printf(DEBUG_MODULE_NAME,"%lf\n",theta);
  return theta > thetaRef;
}

int main()
{
  double i = 1.0;
  double j = 2.0;
  MovementDescriptor* move,*move2, *move3;
  WatchPoint* watchPoint1,*watchPoint2;
  Point* splinePoints;
  Point directionDepart, directionFin;
  Event event;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");



  shared_initModule();

  i2c_initModule();

  printf("avant INIT\n");
  
  INIThctl();

  printf("apres INIT\n");

  move_initModule();

  splinePoints = (Point*) malloc(6*sizeof(Point));
  splinePoints[0].x = 0.0;
  splinePoints[0].y = 0.0;
  splinePoints[1].x = 300.0;
  splinePoints[1].y = 0.0;
  splinePoints[2].x = 600.0;
  splinePoints[2].y = 300.0;
  splinePoints[3].x = 900.0;
  splinePoints[3].y = 600.0;
  splinePoints[4].x = 1800.0;
  splinePoints[4].y = 600.0;
  splinePoints[5].x = 1800.0;
  splinePoints[5].y = 300.0;

  directionDepart.x = 10;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  
  printf("BEGIN of SCENARIO\n");

  move3 = defineSplineMovement(directionDepart, directionFin, splinePoints, 6);

  createEvent(&event,"THETA_SUP_EVENT");
  addWatchPoint(move3, &event,  &thetaSup, &i);

  startMove(move3);

  debug_printf(DEBUG_MODULE_NAME,"Waiting event...\n");
  waitEvent(&event);
  debug_printf(DEBUG_MODULE_NAME,"Event has arived...\n");

  stopMove();
  
  sleep(60);

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");
//  while (1) { sleep(1); }

}
