#include "robot.h"
#include "periodServer.h"

#include <unistd.h>

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#include "move.h"
		
int main()
{
  periodicTask* LeftLineSensor;
  Event* LLSEvent;

  periodicTask* RightLineSensor;
  Event* RLSEvent;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");

  shared_initModule();

  i2c_initModule();

  perServer_initModule();

  
  debug_printf(DEBUG_MODULE_NAME,"BEGIN of SCENARIO\n");


  // Gestion des lignes blanches 
  //****************************
  
  RightLineSensor  = createPeriodicAcquisition(I2C_LEFT_LINE_SENSOR_SLAVE, 0 , 1 << I2C_LEFT_LINE_SENSOR_BIT, 500000);
  LeftLineSensor  = createPeriodicAcquisition(I2C_RIGHT_LINE_SENSOR_SLAVE, 0 , 1 << I2C_RIGHT_LINE_SENSOR_BIT, 500000);
	
  RLSEvent = i2c_getEvent(LeftLineSensor);
  LLSEvent = i2c_getEvent(RightLineSensor);

  waitEvent(LLSEvent);
  waitEvent(RLSEvent);
  waitEvent(LLSEvent);
  waitEvent(RLSEvent);
  waitEvent(LLSEvent);
  waitEvent(RLSEvent);

  debug_printf(DEBUG_MODULE_NAME,"END of SCENARIO\n");

  return 0;
}




