//#include "shared.h"
//#include "move.h"
//#include "relay.h"
//#include "lcd.h"
//#include "i2cManager.h"
//#include "init_hctl.h"
//#include "start_jack.h"
//#include "servo_control.h"

#include "robot.h"
#include "trajectory.h"
#include "stdio.h"  // printf
#include <stdlib.h> // malloc
#include <unistd.h> // sleep
//#include "periodServer.h"
#define DEBUG_MODULE_NAME MAIN
#include "debug.h"
#include "move.h"


extern void InitPlanetEtBras();

unsigned char thetaSup(double x, double y, double theta, void* params)
{
  double thetaRef = *((double*)params);
  return theta > thetaRef;
}

int main()
{
  double i = 1.0;
  double j = 2.0;
  int err;
  int nbrpoint=0;
    
  int k;
  double dummy_x;
  double dummy_y;
  double D,L;
  double gx,gy,gt;
  MovementDescriptor* spline;
  Point *splinePoints;
  Point directionDepart, directionFin;
  MovementDescriptor* rotation1;
  
Event endRotation1Event;
  MovementDescriptor* moveBack;
  Event endMoveBackEvent;
    
  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");


  shared_initModule();
  i2c_initModule();
  
  INIThctl();

  move_initModule();



  printf("depart\n");
  InitTrajectory();
  //InitPlanetEtBras();
  setRobotPos(300,1050,0);
  gt=getTheta();
  gx=getX();
  gy=getY();
  
  splinePoints = (Point*) malloc(30*sizeof(Point));
  directionDepart.x = gx;
  directionDepart.y = gy;
  printf("%lf %lf\n",gx,gy);
  //err=GetTrajectoryToPlanet(directionDepart,DRAPEAU_SECOUR_RIGHT /*planet*/, DRAPEAU_SECOUR_RIGHT/*bras*/,0 ,splinePoints, &nbrpoint,&D,&L );
  directionDepart.x = 0;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  if(err == OK){
 printf("3, nbrpoint=%d\n",nbrpoint);
    /* spline vers la planete */
 splinePoints[0].x = getX();
  splinePoints[0].y = getY();
  splinePoints[1].x = 1200.0;
  splinePoints[1].y = 200.0;
  splinePoints[2].x = 1600.0;
  splinePoints[2].y = 600.0;
  directionDepart.x = 0;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  nbrpoint=3;
       spline = defineSplineMovement(directionDepart, directionFin, splinePoints, nbrpoint);
       setPIDParams(spline,0.3);
       sleep(2);
       startMove(spline);
       sleep(60);

       /* orientation finale */
       gt=getTheta();
       gx=getX();
       gy=getY();
       while(D-gt>3.14159) D-=2*3.14159;
       while(D-gt<-3.14159) D-=2*3.14159;
       rotation1=defineRotationMovement(D);
       setPIDParams(rotation1,0.5);  //0.1
       setMaxSpeed(rotation1,127.0,127.0,MAX_SPEED_PROPORTIONAL);
       createEvent(&endRotation1Event,"END_ROTATION_1_EVENT");
       setEndMoveEvent(rotation1,  &endRotation1Event);
       startMove(rotation1);
       waitEvent(&endRotation1Event);
       
       /* avance , attends, recule */
       if(L>0) k=1;
       else k=-1;
       MoveLinearBasic(fabs(L),k*15);
       sleep(5);
       MoveLinearBasic(-fabs(L),-k*15);
       printf("Trajectory Fin\n");
  }
  else printf("Trajectory Error : %d\n",err);
  
  DeleteTrajectory();

 /*
lcd_initModule();
lcd_clear();
printf("Hello");
lcd_printf("Hello\n");
sleep(3000);
lcd_cleanUpModule();
*/ //err=i2cGet(0x21,0xff);printf("i2c lignes : %x\n",err);

//err=i2cGet(0x22,0xff);printf("i2c lignes : %x\n",err);
//err=i2cGet(0x23,0xff);printf("i2c lignes : %x\n",err);
//  err=i2cGet(0x24,0xff);printf("i2c lignes : %x\n",err);
 ////// err=i2cGet(0x25,0xff);printf("i2c lignes : %x\n",err);

  //err=i2cGet(0x27,0xff);printf("i2c lignes : %x\n",err);
  //err=i2cGet(0x28,0xff);
printf("i2c lignes : %x\n",err); 

  return 1;
}
