#include "robot.h"
//#include "periodServer.h"

#include <unistd.h>

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#include "move.h"

#include <stdlib.h>
#include "trajectory.h"
#define PI 3.14159

int main(int nargs, char*argv[])
{
  Point *splinePoints;
  Point directionDepart;
  Point directionFin;
  int i,err=OK,nbrpoint;
  double D,L,gx,gy,gt;
  MovementDescriptor* spline;
  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");
  
  shared_initModule();
  
  i2c_initModule();
  
  INIThctl();

  move_initModule();
  
  relay_initModule();

  //perServer_initModule();

  debug_printf(DEBUG_MODULE_NAME,"BEGIN of SCENARIO\n");

  InitTrajectory();
  //InitPlanetEtBras();

  // Mouvement jusqu'a une des planetes avec Velcro
  //***********************************************
setRobotPos(300,1050,0);
splinePoints = (Point*) malloc(30*sizeof(Point));
  directionDepart.x = getX();
  directionDepart.y = getY();
  if(nargs>1){
  //err=GetTrajectoryToPlanet(directionDepart,DRAPEAU_SECOUR_RIGHT /*planet*/, DRAPEAU_SECOUR_RIGHT/*bras*/,0 ,splinePoints, &nbrpoint,&D,&L );
  err=GetBestTrajectory(getX(), getY(), 1500, 1050, 0, splinePoints, &nbrpoint);
  for(i=0;i<nbrpoint;i++){
    printf("point[%d]=(%3.0lf, %3.0lf)\n",i,splinePoints[i].x,splinePoints[i].y);
    }
  }
  directionDepart.x = 0;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  if(err == OK){
    
    //splinePoints = (Point*) malloc(3*sizeof(Point));
  splinePoints[0].x = getX();
  splinePoints[0].y = getY();
  splinePoints[1].x = 1200.0;
  splinePoints[1].y = 200.0;
  splinePoints[2].x = 1600.0;
  splinePoints[2].y = 600.0;
  directionDepart.x = 0;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  nbrpoint=3;  

  spline = defineSplineMovement(directionDepart, directionFin, splinePoints, nbrpoint);
  setPIDParams(spline,0.3);
  startMove(spline);
  }
  else printf("Trajectory Error : %d\n",err);

  while (1) {};
}





