#include <gtk/gtk.h>  
#include <unistd.h>
#include <pthread.h>

#include "configHandler.h"
#include "splashScreen.h"
#include "mainWindow.h"
#include "comManager.h"


pthread_t  thread;
pthread_mutex_t mutexGTKLoop;


void threadBody(void * dummy)
{
  double val = 0.0;

  splashScreen_init();
  splashScreen_show();


  mainWindow_init();

  splashScreen_incProgress(0.1);

  comManager_init();

  splashScreen_incProgress(0.1);

  handleConfig();

  splashScreen_setProgress(1.0);

  sleep(1);

  mainWindow_show();

  sleep(1);

  splashScreen_hide();

}

gint idle_callback (gpointer data)
{
  pthread_mutex_unlock(&mutexGTKLoop);
  usleep(50000);
  pthread_mutex_lock(&mutexGTKLoop);
  return 1;
}


int main (int argc, char *argv[])
{
  g_thread_init(NULL);

    gtk_init (&argc, &argv);
    

    gtk_idle_add (&idle_callback, NULL);

    pthread_mutex_init(&mutexGTKLoop,NULL);

    pthread_create(&thread, NULL, &threadBody, NULL);
   
    pthread_mutex_lock(&mutexGTKLoop);

    gdk_threads_enter();

    gtk_main ();

    gdk_threads_leave();

    
    return 0;
}
