#ifndef __DRAWING_AREA_H__
#define __DRAWING_AREA_H__

#include <gtk/gtk.h>  

#include <xmlmemory.h>
#include <parser.h>

#define NB_OF_LAYERS 2
#define BACKGROUND_LAYER 0
#define ROBOT_LAYER 1

typedef struct Layer
{
  GdkPixmap *pixmap;
  GdkPixmap *mask;
  int isVisible;
  void (*createBitmapProc)(struct Layer*);
  struct Layer* next;
  double rotX, rotY, rotTheta;
  double xMax;
  double yMax;
} Layer;

extern GtkWidget *drawingArea_init();

extern void drawingArea_show();

extern void setXMLBackground(xmlDocPtr doc, xmlNodePtr cur);

extern void setZoom(float zoom);

extern void drawRobot(Layer* layer, int fill, double x, double y, double theta);

extern Layer* addDrawingLayer(void (*createBitmapProc)(struct Layer*));

extern void drawingAreaRedraw();

#endif // __DRAWING_AREA_H__
