#include "drawingPanel.h"

#include "drawingArea.h"

static GtkWidget *scrolledWindow;

static GtkWidget *zoomCombo;

void combo_change_handler (GtkWidget *widget, GdkEvent *event, gpointer *data)
{
  char *buffer;

  buffer = gtk_entry_get_text(GTK_COMBO(zoomCombo)->entry);

  printf("zoom : %s\n",buffer);
  
  if (!strcmp(buffer,"10%"))
    setZoom(0.1);

  if (!strcmp(buffer,"20%"))
    setZoom(0.2);

  if (!strcmp(buffer,"30%"))
    setZoom(0.3);

  if (!strcmp(buffer,"40%"))
    setZoom(0.4);

  if (!strcmp(buffer,"50%"))
    setZoom(0.5);

  if (!strcmp(buffer,"75%"))
    setZoom(0.75);

  if (!strcmp(buffer,"100%"))
    setZoom(1.0);

  if (!strcmp(buffer,"125%"))
    setZoom(1.25);
 
  if (!strcmp(buffer,"150%"))
    setZoom(1.5);

  if (!strcmp(buffer,"200%"))
    setZoom(2.0);

}

static GtkWidget *toolPanel_init()
{
  GtkWidget *hbox;
  GtkWidget *label;
  GList *glist;

  hbox=gtk_hbox_new(FALSE, 0);
  gtk_widget_show (hbox);
  
  label = gtk_label_new ("Zoom : ");
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 5);
  gtk_widget_show (label);

  zoomCombo = gtk_combo_new();
  gtk_entry_set_editable(GTK_COMBO(zoomCombo)->entry, FALSE); 
  gtk_box_pack_start (GTK_BOX (hbox), zoomCombo, FALSE, TRUE, 5);
  gtk_widget_show (zoomCombo);

  glist = g_list_alloc();
  g_list_append(glist, strdup("10%"));
  g_list_append(glist, strdup("20%"));
  g_list_append(glist, strdup("30%"));
  g_list_append(glist, strdup("40%"));
  g_list_append(glist, strdup("50%"));
  g_list_append(glist, strdup("100%"));
  g_list_append(glist, strdup("125%"));
  g_list_append(glist, strdup("150%"));
  g_list_append(glist, strdup("175%"));

  gtk_combo_set_popdown_strings(GTK_COMBO(zoomCombo),glist);
  gtk_entry_set_text(GTK_COMBO(zoomCombo)->entry,"100%");

  gtk_signal_connect(GTK_COMBO(zoomCombo)->entry,
		     "changed",
		     GTK_SIGNAL_FUNC(combo_change_handler),
		     NULL);


  return hbox;
}

GtkWidget *drawingPanel_init()
{
  GtkWidget *drawingArea;
  GtkWidget *hbox;
  GtkWidget *zoom;
  GtkWidget *toolBox;

  hbox=gtk_vbox_new(FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (hbox), 10);
  gtk_widget_show (hbox);

  scrolledWindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledWindow),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
//  gtk_container_border_width (GTK_CONTAINER (scrolledWindow), 10);
  gtk_widget_show (scrolledWindow);
  
  gtk_box_pack_start (GTK_BOX (hbox), scrolledWindow, TRUE, TRUE, 5);

//  gtk_paned_add2(GTK_PANED (hbox), scrolledWindow);

  drawingArea = drawingArea_init();
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW (scrolledWindow), drawingArea);
  drawingArea_show();
  

  toolBox = toolPanel_init();
  gtk_box_pack_start (GTK_BOX (hbox), toolBox, FALSE, FALSE, 5);
  gtk_widget_show (toolBox);


  

  return hbox;
}

void drawingPanel_show()
{
  gtk_widget_show (scrolledWindow);
}
