#include <stdio.h>
 
#include <xmlmemory.h>
#include <parser.h>

#include <dlfcn.h>

void parseModule(xmlDocPtr doc, xmlNodePtr cur)
{
  char* moduleName;
  void *dlHandle;
  void (*procPtr)();

  printf("Parse module\n");
  cur = cur->xmlChildrenNode;
  while (cur != NULL)
    {
      printf("%s\n",cur->name);
      if (!strcmp(cur->name,"name"))
	{
	  printf("Load module (%s)...\n",xmlNodeListGetString(doc, cur->xmlChildrenNode, 1));
	}
      if (!strcmp(cur->name,"location"))
	{
	  moduleName=xmlNodeListGetString(doc, cur->xmlChildrenNode, 1);
	  if (!(dlHandle = dlopen(moduleName,RTLD_LAZY)))
	    {
	      printf("Error loading module : %s\n",dlerror());
	    }

	  printf("Init...\n");
	  procPtr = dlsym(dlHandle,"initModule");
	  if (!procPtr)
	    {
	      printf("Error getting address of initModule : %s\n",dlerror());
	    }

	  (*procPtr)();
	}
      cur = cur->next;
    }
}

int main()
{
  xmlDocPtr doc;
  xmlNodePtr cur;
  xmlNsPtr ns;


  printf("Start...\n");

  doc = xmlParseFile("config.xml");
  if (doc == NULL) 
    {
      printf("Error parsing config.xml\n");
      return -1;
    };

  cur = xmlDocGetRootElement(doc);
  
  ns = xmlSearchNsByHref(doc, cur, "http://www.gege.org/coreff/config/1.0");
  if (ns == NULL) {
    printf("This file is not a Config file !\n");
  }

  if (strcmp(cur->name, "config")) {
    printf("The root element is not Config !!!!\n");
  }

  cur = cur->xmlChildrenNode;
  while (cur != NULL)
    {
      printf("%s\n",cur->name);
      if (!strcmp(cur->name,"module"))
	{
	  parseModule(doc,cur);
	  printf("-->%s<--\n",xmlNodeListGetString(doc, cur->xmlChildrenNode, 1));
	}
      cur = cur->next;
    }

  xmlFreeDoc(doc);
 
  printf("End...\n");

}
