#include <stdio.h>

#include "mainWindow.h"

#include "gtkMutex.h"

GtkWidget *createCoderFrame()
{
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *leftCoderLabel, *rightCoderLabel;
  
  frame = gtk_frame_new(" Coder Values ");
  gtk_widget_show (frame);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox), 10);
  gtk_widget_show (vbox);

  gtk_container_add (GTK_CONTAINER (frame), vbox);

  leftCoderLabel = gtk_label_new ("Left : 0");
  gtk_widget_show (leftCoderLabel);
  gtk_box_pack_start (GTK_BOX (vbox), leftCoderLabel, FALSE, FALSE, 5);

  rightCoderLabel = gtk_label_new ("Right : 0");
  gtk_widget_show (rightCoderLabel);
  gtk_box_pack_start (GTK_BOX (vbox), rightCoderLabel, FALSE, FALSE, 5);

  
  return frame;
}

void hardReset (GtkWidget *widget, gpointer data)
{
  mainWindow_addLog_NM("Performing HCTL Hard Reset...");
}

void softReset (GtkWidget *widget, gpointer data)
{
  mainWindow_addLog_NM("Performing HCTL Soft Reset...");
}

GtkWidget *createResetFrame()
{
  GtkWidget *frame;
  GtkWidget *vbox;
  GtkWidget *softResetButton, *hardResetButton;
  
  frame = gtk_frame_new(" HCTL Reset ");
  gtk_widget_show (frame);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox), 10);
  gtk_widget_show (vbox);

  gtk_container_add (GTK_CONTAINER (frame), vbox);

  softResetButton = gtk_button_new_with_label ("Soft Reset");
  gtk_signal_connect (GTK_OBJECT (softResetButton), "clicked",
                        GTK_SIGNAL_FUNC (softReset), NULL);

  gtk_widget_show (softResetButton);
  gtk_box_pack_start (GTK_BOX (vbox), softResetButton, FALSE, FALSE, 5);

  hardResetButton = gtk_button_new_with_label ("Hard Reset");
  gtk_signal_connect (GTK_OBJECT (hardResetButton), "clicked",
		      GTK_SIGNAL_FUNC (hardReset), NULL);
  gtk_widget_show (hardResetButton);
  gtk_box_pack_start (GTK_BOX (vbox), hardResetButton, FALSE, FALSE, 5);

  
  return frame;
}

void initModule()
{
  GtkWidget *empty_notebook_page;
  GtkWidget *label;
  GtkWidget *softResetButton, *hardResetButton;
  GtkWidget *vbox;

  printf("Init module\n");

//  pthread_mutex_lock(&mutexGTKLoop);

  vbox = gtk_vbox_new (FALSE, 0);
  empty_notebook_page = vbox;
  gtk_container_border_width (GTK_CONTAINER (vbox), 10);
  gtk_widget_show (empty_notebook_page);

  gtk_box_pack_start (GTK_BOX (vbox), createCoderFrame(), FALSE, FALSE, 5);

  gtk_box_pack_start (GTK_BOX (vbox), createResetFrame(), FALSE, FALSE, 5);

  mainWindow_addNoteBookPage(empty_notebook_page);
  label = gtk_label_new ("HCTL");
  mainWindow_setNoteBookPageName(empty_notebook_page, label);

  mainWindow_addLog("HCTL module initialized...");

//  pthread_mutex_unlock(&mutexGTKLoop);
}
