#include <sys/socket.h>
#include <netinet/in.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <pthread.h>

#define PORT 5842

pthread_t readThread;

int sockClient;

double x = 0.0;
double y = 0.0;
double theta = 0.0;

typedef struct NetCallBack {
  char* prefix;
  void (*callback)(char*);
  struct NetCallBack *next;
} NetCallBack;

NetCallBack* netCallBackList = NULL;

void registerNetCallBack(char* prefix, void (*callback)(char*))
{
  NetCallBack* netCallBackElem;

  netCallBackElem = (NetCallBack*) malloc(sizeof (NetCallBack));
  netCallBackElem->prefix = strdup(prefix);
  netCallBackElem->callback=callback;
  netCallBackElem->next=NULL;
  
  if (netCallBackList == NULL)
    netCallBackList = netCallBackElem;
  else
    {
      netCallBackElem->next = netCallBackList;
      netCallBackList = netCallBackElem;
    }
}

void pingCallBack()
{
	char buffer[50];
	strcpy(buffer,"PONG\n");
	write(sockClient, buffer, strlen(buffer)); ;
	
	x = x + 100.0;	
	y = y + 100.0;
	theta = theta + 0.1;

	sprintf(buffer,"POS X:%f Y:%f T:%f\n",x, y, theta);
	write(sockClient, buffer, strlen(buffer)); 

	printf("Ping callback\n");
}

void readThreadBody()
{
  int dummy;
  char buffer[100];
  char c;
  int index;
  NetCallBack* p;

  while (1)
    {
      index = 0;
      c='\0';
      while ((dummy >= 0) && (c != '\n'))
	{
	  dummy = read(sockClient,&c,1);
	  if (dummy > 0)
	    buffer[index++]=c;
	}
      buffer[index]='\0';

      if (c != '\n')
	{
	  printf("Exiting reader thread (%s)\n",strerror(errno));
	  return;
	}
      else
	{
	  printf(">> %s\n",buffer);
	  p = netCallBackList;
	  while (p != NULL)
	  {
		  printf("%s == %s\n",buffer,p->prefix);
	    if (strlen(strstr(buffer,p->prefix))==strlen(buffer))
		{
			printf("handler found...\n");
			p->callback(buffer);
			p=p->next;
		}	
	  }
		
	}
    }
}




int main()
{
  struct sockaddr_in sin,from;
  int len;
  int s;
  char jocker;
  char c;
  char buffer[10];
  int count;
  int i;

  printf("Create socket...");
  s = socket(AF_INET, SOCK_STREAM, 0);
  if (s < 0)
    {
      printf("Error (%s)\n",strerror(errno));
      return -1;
    }
  else
    {
      printf("OK\n");
    }

  sin.sin_family=AF_INET;
  sin.sin_port=htons(PORT);
  sin.sin_addr.s_addr=htonl(INADDR_ANY);

  printf("Binding on port %d...",PORT);
  if (bind(s, &sin, sizeof(sin)) < 0)
    {
      printf("Error (%s)\n",strerror(errno));
      return -1;
    }
  else
    {
      printf("OK\n");
    }

  printf("Server declaration...");
  if (listen(s,2) < 0)
    {
      printf("Error (%s)\n",strerror(errno));
      return -1;
    }
  else
    {
      printf("OK\n");
    }

  for (;;) {

    len = sizeof(from);

    printf ("Waiting connections...");
    if ((sockClient=accept(s,&from,&len)) < 0)
      {
	printf("Error (%s)\n",strerror(errno));
	return -1;
      }
    else
      {
	printf("OK\n");
      }

     registerNetCallBack("PING",pingCallBack);

    
     pthread_create(&readThread, NULL, &readThreadBody, NULL);
     pthread_join(&readThread, NULL);
     while (1) {} 
     //close(sockClient);   /* parent releases file */
  }
}
