/* lancement des trucs "utiles" */
/* Kali, 14 mai 2000 */


#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "stdio.h"

int
call_2arg(const char * file, const char* arg1, const char* arg2)
{
  int result;

  int pid;
  
  pid = fork();

  if (pid == -1) 
  	{ 
	  fprintf(stderr, "Erreur : impossible de forker\n"); 
	  exit(42);
	}
	  
  
  if (pid == 0)
	{
	  execlp(file, file, arg1, arg2 , NULL);
	  fprintf(stderr, "Grosse merde, la (execlp)...\n");
	  exit(12);
	}
  else
	{
	  wait(&result);
	}
  return result;
}

int
call(const char * file, const char* arg)
{
  int result;

  int pid;
  
  pid = fork();

  if (pid == -1) 
  	{ 
	  fprintf(stderr, "Erreur : impossible de forker\n"); 
	  exit(42);
	}
	  
  
  if (pid == 0)
	{
	  execlp(file, file, arg, NULL);
	  fprintf(stderr, "Grosse merde, la (execlp)...\n");
	  exit(12);
	}
  else
	{
	  wait(&result);
	}
  return result;
}

void
insmod(const char * module)
{
  if (call_2arg("/sbin/insmod", "-f", module)==0)
  {
	  fprintf(stdout, "module %s installe\n",module);
  }
  else
  {
	  fprintf(stderr, "Echec de insmod %s\n",module);
	  exit(64);
  }
}

int main()
{

  /* Chargement du module temps reel */
	
  insmod("/chipdisk/modules/i2c-core.o");	
  insmod("/chipdisk/modules/i2c-dev.o");	
  insmod("/chipdisk/modules/i2c-algo-pcf.o");	
  insmod("/chipdisk/modules/i2c-elektor.o");  	
  insmod("/chipdisk/modules/module.o");
  
  call ("/sbin/lsmod","");
  
  /* Lancement de l"appli de controle */

  /* attention, elle doit jamais rendre la main */
  
  call("/chipdisk/control","");
  
  while (1);
  
  return 0;
}
