/* Demarage du robot */
/* Kali, Axel, 13 mai 2000 */


#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "stdio.h"

int
call(const char * file, const char* arg)
{
  int result;

  int pid;
  
  pid = fork();

  if (pid == -1) 
  	{ 
	  fprintf(stderr, "Erreur : impossible de forker\n"); 
	  exit(42);
	}
	  
  
  if (pid == 0)
	{
	  execlp(file, file, arg, NULL);
	  fprintf(stderr, "Grosse merde, la (execlp)...\n");
	  exit(12);
	}
  else
	{
	  wait(&result);
	}
  return result;
}

void
insmod(const char * module)
{
  if (call ("/sbin/insmod", module)==0)
  {
	  fprintf(stdout, "module %s installe\n",module);
  }
  else
  {
	  fprintf(stderr, "Echec de insmod %s\n",module);
	  exit(64);
  }
}

int main()
{
  /* Mountage du /proc et de /chipdisk */

  if (call ("/sbin/mount", "/chipdisk")==0)
  {
	  fprintf(stdout, "Montage de /chipdisk OK \n");
  }
  else
  {
	  fprintf(stderr, "Echec du montage /chipdisk\n");
	  exit(30);
  }

  if (call ("/sbin/mount", "/proc")==0)
  {
	  fprintf(stdout, "Montage de /proc OK \n");
  }
  else
  {
	  fprintf(stderr, "Echec du montage /proc\n");
	  exit(30);
  }
  
	
  /* Installation des modules Temps Rel */

  insmod("/modules/rtl_time.o");
  insmod("/modules/rtl_sched.o");
  insmod("/modules/rtl_posixio.o");
  insmod("/modules/rtl_fifo.o");
  insmod("/modules/mbuff.o");
 
  call ("/sbin/lsmod","");

  call ("/chipdisk/go","");
  
  while(1); /* ben oui, c init :) */
		  
  return 0;
}
