#include "robot.h"
#include "periodServer.h"

#include <unistd.h>

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#include "move.h"

#define PI 3.14159

int main()
{
  MovementDescriptor* move;
  Event endEvent;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");

  shared_initModule();

  i2c_initModule();

  INIThctl();

  move_initModule();
  
  electro_initModule();

  relay_initModule();

  perServer_initModule();

  debug_printf(DEBUG_MODULE_NAME,"BEGIN of SCENARIO\n");

  move = defineBasicLinearMovement(100.0, 10.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

  move = defineBasicLinearMovement(100.0, 20.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

  move = defineBasicLinearMovement(200.0, 5.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

  move = defineBasicLinearMovement(100.0, -10.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

  move = defineBasicLinearMovement(100.0, -20.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

  move = defineBasicLinearMovement(200.0, -5.0);
  createEvent(&endEvent,"END_MOVE");
  setEndMoveEvent(move,  &endEvent);
  startMove(move);
  waitEvent(&endEvent);

   debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");

  return 0;
}




