#include "robot.h"

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

int main()
{
  MovementDescriptor* moveToBigStar;
  Event endMoveToBigStarEvent;

  MovementDescriptor* rotationRealign;
  Event endRotationRealignEvent;
 
  MovementDescriptor* rotationLeft;
  Event endRotationLeftEvent;

  MovementDescriptor* rotationRight;
  Event endRotationRightEvent;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");

  shared_initModule();

  i2c_initModule();

  INIThctl();

  move_initModule();
  
  electro_initModule();

  relay_initModule();

  
 
  
  
  /*
  move = defineRotationMovement(3.1415);

  setMaxSpeed(move, 0.0 , 127.0 , MAX_SPEED_NOT_PROPORTIONAL);

  watchPoint1 = addWatchPoint(move,&thetaSup,&i);
  setPermanentWatchPoint(watchPoint1);
  watchPoint2 = addWatchPoint(move,&thetaSup,&j);
  startMove(move);

  debug_printf(DEBUG_MODULE_NAME,"Waiting theta>1\n");

  waitWatchPoint(watchPoint1);
  
  debug_printf(DEBUG_MODULE_NAME,"OK Theta>1\n");

  //  stopMove();

   debug_printf(DEBUG_MODULE_NAME,"Waiting theta>2\n");

  waitWatchPoint(watchPoint2);
  
  debug_printf(DEBUG_MODULE_NAME,"OK Theta>2\n");

  stopMove();

  sleep(1);
  */

  /*
  move2 = defineLinearMovement(1000.0);
  startMove(move2);

  sleep(30);
  */
  
  printf("BEGIN of SCENARIO\n");

  globalState->ServosCons[0]=0;
  globalState->ServosCons[1]=29;
  globalState->ServosCons[2]=234;

  // move moveToBigStar

  createEvent(&endMoveToBigStarEvent,"END_MOVE_TO_BIG_STAR_EVENT");

  moveToBigStar = defineLinearMovement(1140.0);
  setPIDParams(moveToBigStar, 0.3);
//  setMaxSpeed(moveToBigStar, 90, 90, MAX_SPEED_PROPORTIONAL);
  setRefPoint(moveToBigStar, 100.0, 0.0);
  setEndMoveEvent(moveToBigStar,  &endMoveToBigStarEvent);


  // move rotationRealign
  createEvent(&endRotationRealignEvent,"END_ROTATION_REALIGN_EVENT");

  rotationRealign= defineRotationMovement(0.0);
  setEndMoveEvent(rotationRealign,  &endRotationRealignEvent);

  
  // rotation left
  createEvent(&endRotationLeftEvent,"END_ROTATION_LEFT_EVENT");

  rotationLeft = defineRotationMovement(1.0);
  setEndMoveEvent(rotationLeft,&endRotationLeftEvent);

  // rotation right
  createEvent(&endRotationRightEvent,"END_ROTATION_RIGHT_EVENT");

  rotationRight = defineRotationMovement(2.0);
  setEndMoveEvent(rotationRight,&endRotationRightEvent);


/*
  startJackDetection();

  debug_printf(DEBUG_MODULE_NAME,"Wait jack off\n");
  waitJackOff();
  debug_printf(DEBUG_MODULE_NAME,"Wait jack on\n");
  waitJackOn();
  debug_printf(DEBUG_MODULE_NAME,"Wait jack off\n");
  waitJackOff();
 
  endJackDetection();
*/

  debug_printf(DEBUG_MODULE_NAME,"WAIT...\n");
  sleep(10);

  ///////////// AVANCE ETOILE
  startMove(moveToBigStar);

  // servos  bras
  globalState->ServosCons[0]=240;

  armMotor(ON);
  
  waitEvent(&endMoveToBigStarEvent);
  debug_printf(DEBUG_MODULE_NAME,"End linear movement...\n");

  onElectro(1);
   
  sleep(1); 


  //////////////// REALIGN
  debug_printf(DEBUG_MODULE_NAME,"Realign...\n");
  startMove(rotationRealign);

  armMotor(OFF);

  // servos bras
  globalState->ServosCons[0]=0;

  waitEvent(&endRotationRealignEvent);
  debug_printf(DEBUG_MODULE_NAME,"End realign movement...\n");


  debug_printf(DEBUG_MODULE_NAME,"Rotation left...\n");
  startMove(rotationLeft);
  waitEvent(&endRotationLeftEvent);
  debug_printf(DEBUG_MODULE_NAME,"End rotation left...\n");
  

  sleep(60); 

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");
//  while (1) { sleep(1); }

}
