#include "robot.h"
#include "periodServer.h"

#include <unistd.h>
#include <termios.h>
#include <stdio.h>
#include <errno.h>

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#include "move.h"

#define PI 3.14159

struct termios confterm;

void display_menu()
{
  printf("8 -> avance\n");
  printf("2 -> recule\n");
  printf("4 -> tourne gauche\n");
  printf("6 -> tourne droite\n");
  printf("5 -> stop\n");    
}

int currentLeftSpeed = 0;
int currentRightSpeed = 0;

void handle8()
{
  currentLeftSpeed=currentLeftSpeed+5;
  currentRightSpeed=currentRightSpeed+5;
  printf("Speed %d %d\n",currentLeftSpeed,currentLeftSpeed);
  globalState->rightSpeedCons=-currentRightSpeed;
  globalState->leftSpeedCons=-currentLeftSpeed;
}

void handle2()
{
  currentLeftSpeed=currentLeftSpeed-5;
  currentRightSpeed=currentRightSpeed-5;
  printf("Speed %d %d\n",currentLeftSpeed,currentLeftSpeed);
  globalState->rightSpeedCons=-currentRightSpeed;
  globalState->leftSpeedCons=-currentLeftSpeed;
}

void handle4()
{
   currentLeftSpeed=currentLeftSpeed-5;
   currentRightSpeed=currentRightSpeed+5;
   printf("Speed %d %d\n",currentLeftSpeed,currentLeftSpeed);
   globalState->rightSpeedCons=-currentRightSpeed;
   globalState->leftSpeedCons=-currentLeftSpeed;
}

void handle6()
{
  currentLeftSpeed=currentLeftSpeed+5;
  currentRightSpeed=currentRightSpeed-5;
  printf("Speed %d %d\n",currentLeftSpeed,currentLeftSpeed);
  globalState->rightSpeedCons=-currentRightSpeed;
  globalState->leftSpeedCons=-currentLeftSpeed;
}

int main()
{  
  float speed1, speed2;
  char rep;
  int s1, s2;

  shared_initModule();

  i2c_initModule();

  INIThctl();

  move_initModule();

 
  
  /*passage en mode raw*/
  tcgetattr(0,&confterm);
  confterm.c_lflag = confterm.c_lflag & ~ICANON;
  confterm.c_cc[VMIN]=1;
  tcsetattr(0,TCSANOW,&confterm);

  while (1)
        {
          display_menu();
          read(0,&rep,1);

            printf("---- %c ----\n",rep);
	    switch (rep)
	      {
	      case '[' : 
		{
		  read(0,&rep,1);
		  printf("OK %c\n",rep);
		  switch (rep)
		    {
		    case 'A' : handle8(); break;
		    case 'B' : handle2(); break;
		    case 'D' : handle4(); break;
		    case 'C' : handle6(); break;
		    }
		  break;
		}
		  
	      case '8' : 
		{
		  handle8();
		  break;
		}
	      case '2' : 
		{
		  handle2();
		  break;
		}       
		
	      case '4' : 
		{
		  handle4();
		  break;
		}
	      case '6' : 
		{
		  handle6();
		  break;
		}
	      case '5' :
	      case ' ' : 
		{
		  currentLeftSpeed=currentLeftSpeed=0;
		  currentRightSpeed=currentRightSpeed=0;
		  printf("Speed %d %d\n",currentLeftSpeed,currentLeftSpeed);
		  globalState->rightSpeedCons=-currentRightSpeed;
		  globalState->leftSpeedCons=-currentLeftSpeed;
		  break;
		}
	      }
        }
  
  return 0;
}




