#include <gtk/gtk.h>  

#include <pthread.h>

#include "gtkMutex.h"

static GtkWidget *window;
static GtkWidget *table;
static GtkWidget *progressLabel;
static GtkWidget *pbar;

void splashScreen_init()
{
  pthread_mutex_lock(&mutexGTKLoop);
  
  window = gtk_window_new (GTK_WINDOW_POPUP);
  gtk_window_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER);

  table = gtk_table_new(3,2,TRUE);
  gtk_container_add (GTK_CONTAINER (window), table);


  gtk_container_border_width (GTK_CONTAINER (window), 10);
    
  /* Cration d'un nouveau bouton portant le label 
   * "Bonjour tout le monde". */

  progressLabel = gtk_label_new ("Ready...");


  gtk_table_attach_defaults(GTK_TABLE(table), progressLabel, 0,2,0,1);

  /* L'tape finale consiste  afficher ce nouveau widget... */

  gtk_widget_show (progressLabel);


  pbar = gtk_progress_bar_new ();
  gtk_table_attach_defaults(GTK_TABLE(table), pbar, 0,2,1,2);

  gtk_widget_show (pbar);


  gtk_widget_show (table);
  
  pthread_mutex_unlock(&mutexGTKLoop);
}


void splashScreen_show()
{
  pthread_mutex_lock(&mutexGTKLoop);
  gtk_widget_show (window);
  pthread_mutex_unlock(&mutexGTKLoop);
}

void splashScreen_hide()
{
  pthread_mutex_lock(&mutexGTKLoop);
  gtk_widget_hide (window);
  pthread_mutex_unlock(&mutexGTKLoop);
}

void splashScreen_setLabel(char* label)
{
  pthread_mutex_lock(&mutexGTKLoop);
  gtk_label_set (GTK_LABEL(progressLabel),label);
  pthread_mutex_unlock(&mutexGTKLoop);
}

void splashScreen_setProgress(double val)
{
  if (val > 1.0) val=1.0;

  pthread_mutex_lock(&mutexGTKLoop);
  gtk_progress_bar_update (GTK_PROGRESS_BAR (pbar), val);
  pthread_mutex_unlock(&mutexGTKLoop);
}

void splashScreen_incProgress(double val)
{
  val =+ gtk_progress_get_current_percentage (GTK_PROGRESS_BAR (pbar));

  if (val > 1.0) val=1.0;

  pthread_mutex_lock(&mutexGTKLoop);
  gtk_progress_bar_update (GTK_PROGRESS_BAR (pbar), val);
  pthread_mutex_unlock(&mutexGTKLoop);
}
