#include <pthread.h>

#include "electro.h"

#include "i2cManager.h"

#define DEBUG_MODULE_NAME ELECTRO
#include "debug.h"

void* electroThreadBody(unsigned char* electroIDPtr)
{
  int electroID = *electroIDPtr;

  sleep(2);
  i2cSend(I2C_ELECTRO_SLAVE, 1 << electroID, 1 << electroID);
  
  debug_printf(DEBUG_MODULE_NAME,"Set to off electro number %d\n",electroID);

  pthread_exit(NULL);
  
  return NULL;
}

void electro_initModule()
{
  i2cSend(I2C_ELECTRO_SLAVE, 0, 0x00);
}

void electro_cleanUpModule()
{
  i2cSend(I2C_ELECTRO_SLAVE, 0, 0x00);
}

void onElectro(unsigned char electroID)
{
  pthread_t electroThread;
  unsigned char* id;

  debug_printf(DEBUG_MODULE_NAME,"Set to on electro number %d\n",electroID);
  i2cSend(I2C_ELECTRO_SLAVE,0 << electroID, 1 << electroID);

  id = (unsigned char*) malloc(sizeof(unsigned char));
  (*id)=electroID;

  pthread_create(&electroThread,NULL, electroThreadBody,id);
}
