#include <linux/cons.h>
#include <rtlinux/rtl_sched.h>

#include "HCTLControl.h"


#include "hct.h"

#include "shared.h"
#include <rtl_sync.h>

// rien a foutre la !!!! pour l'init de l'i2c
#include "linux/i2c-algo-pcf.h"
extern struct i2c_adapter pcf_isa_ops;

//#include "global_state.h"


#define STARTUP_ACCELERATION 40

volatile Global_State_T * globalState;

int currentRightSpeedCons = 0;
int currentLeftSpeedCons = 0;

#define PERIOD_HCTL_CONTROL_TASK_NANO 800000
pthread_t HCTLControlTaskHandle;

/***************************************************
       S E T T I N G   M O T O R S   S P E E D
****************************************************/




void set_speed( int vitesse1, int vitesse2)
{

#ifdef __RT_MODULE__
  long state;
  rtl_no_interrupts( state );
#endif

  //vit_com_int( 1, vitesse1);
  vit_com_int( 2, vitesse2 );
  vit_com_int( 1, vitesse1);

#ifdef  __RT_MODULE__
  rtl_restore_interrupts( state );
#endif

//  vit_com1( abs(vitesse1)%16, (abs(vitesse1)*16)%256, vitesse1>=0?1:-1);
//  vit_com2( abs(vitesse2)%16, (abs(vitesse2)*16)%256, vitesse2>=0?1:-1);

//  printf("toto");
//  vit_com1(0xff, 0xf0, 1); 
	
//  vit_com1((abs(vitesse1)>>4)&0xff, ((abs(vitesse1)&0x0f)<<4)|0x00, vitesse1>=0?1:-1);
// printf("%d %d %d %d",vitesse1, (abs(vitesse1)>>4)&0xff, ((abs(vitesse1)&0x0f)<<4)|0x0f, vitesse1>=0?1:-1);

//  vit_com2((abs(vitesse2)>>4)&0xff, ((abs(vitesse2)%0x0f)<<4)|0x00, vitesse2>=0?1:-1); 

}

void hctlSetMotorSpeed(int aleftSpeed, int arightSpeed)
{
  int rightSpeed = aleftSpeed;
  int leftSpeed  = arightSpeed;
  // This year, the we have to reverse the direction and side :) - K
  
  if (rightSpeed>127)
    rightSpeed = 127;

  if (leftSpeed>127)
    leftSpeed = 127;

  if (rightSpeed<-127)
    rightSpeed = -127;
    

  if (leftSpeed<-127)
    leftSpeed = -127;

//  globalState->rightSpeedCons = -rightSpeed;
//  globalState->leftSpeedCons = -leftSpeed;
  
  set_speed((int)rightSpeed,(int)leftSpeed);
}


/***************************************************
       G E T T I N G   M O T O R S   P O S
****************************************************/

int hctlGetRightPos()
{
  int dummy;

#ifdef __RT_MODULE__
  long state;
  rtl_no_interrupts( state );
#endif 

  dummy =lecture_position_2();

#ifdef __RT_MODULE__
  rtl_restore_interrupts( state );
#endif

  return dummy;
}

int hctlGetLeftPos()
{
  int dummy;

#ifdef __RT_MODULE__
  long state;
  rtl_no_interrupts( state );
#endif

  dummy=lecture_position_1();

#ifdef __RT_MODULE__
  rtl_restore_interrupts( state );
#endif

  return dummy;
}


/***************************************************
            I N I T I A L I S A T I O N S
****************************************************/


/* This is a copy of the 1998's source code */
static void initHCTL()
{
  int A1, B1, K1, T1, offset1;
  int A2, B2, K2, T2, offset2;

#ifdef __RT_MODULE__
  long state;
  rtl_no_interrupts( state );
#endif

  reinitialisation_logiciel( 2 );
  reinitialisation_logiciel( 1 );
  initialisation_repos( 1 );
  initialisation_repos( 2 );
  config_out( 1, 1 );
  config_out( 2, 1 );
  A1 = A2 = 0xE5;
  B1 = B2 = 0x40;
  K1 = K2 = 0x20;
//2000  K1 = K2 = 0x16;
  T1 = T2 = 0x40;

  offset1 = offset2 = 0;
  filter( 1, A1, B1, K1 );
  filter( 2, A2, B2, K2 );
  timer( 1, T1 );
  timer( 2, T2 );
  pwm( 1, offset1 );
  pwm( 2, offset2 );

  raz_dist(1);
  raz_dist(2);
  
#ifdef __RT_MODULE__
  rtl_restore_interrupts( state );
#endif

  //  old_l_right = 0;
  //old_l_left = 0;

  //  a_max=0.3; // cas de la commande hctl mode vitesse proportionnelle ne pas depasser 0.5
  //v1_old=v2_old=0.0;
} /*initialisation*/


/* This is used to grant access to the io ports */
void makeIOPerm()
{
#ifndef __RT_MODULE__
  if (iopl(3)) {perror("Error IOPerm..."); exit(1);} 
#endif
}


static void setMode()
{
#ifdef __RT_MODULE__
  long state;
  rtl_no_interrupts( state );
#endif

  com_int_vit( 1 );
  com_int_vit( 2 );
//  com_prop_vit(1);
//  com_prop_vit(2);
  set_speed(0,0);
  mode_commande(1);
  mode_commande(2);

#ifdef __RT_MODULE__
  rtl_restore_interrupts( state );
#endif
}

void setAcc(int acc)
{  
  struct deux_reg vit1, vit2;

#ifdef __RT_MODULE__
  long  state;
  rtl_no_interrupts( state );
#endif

 vit1.octet1=0;
 vit2.octet1=0;
 vit1.octet2=acc;
 vit2.octet2=acc;
 acc_trap( 1, vit1.octet1, vit1.octet2 );
 acc_trap( 2, vit2.octet1, vit2.octet2 );

#ifdef __RT_MODULE__ 
  rtl_restore_interrupts( state );
#endif

}



/*****************************************
             TASK HANDLING
******************************************/

void* HCTLControl(void* junk)
{
   rtl_printf("Main HCTL loop launched\n");

   

   while (1)
      {
		if (globalState->requestHCTLReset)
		  {
			initHCTL();  
			setAcc(STARTUP_ACCELERATION);
  
			setMode();
			hctlSetMotorSpeed(0,0);

			globalState->requestHCTLReset=0;
		  }

		// rien a foutre la, pour l'init de l'i2c
		if (globalState->requestPCFReset)
		  {
		    pcf_init_8584(pcf_isa_ops.algo_data);
		    globalState->requestPCFReset=0;
		  }

		globalState->rightLength = hctlGetRightPos();
		globalState->leftLength = hctlGetLeftPos();

		globalState->rightPWM = hctlGetRightPWM();
		globalState->leftPWM = hctlGetLeftPWM();

		//rtl_printf("l : %d r : %d\n",globalState->leftSpeedCons,globalState->rightSpeedCons);
		pthread_wait_np();
		
		if ((globalState->rightSpeedCons != currentRightSpeedCons) || 
			(globalState->leftSpeedCons != currentLeftSpeedCons))
		  {
			hctlSetMotorSpeed(globalState->leftSpeedCons,globalState->rightSpeedCons);
			currentRightSpeedCons = globalState->rightSpeedCons;
			currentLeftSpeedCons = globalState->leftSpeedCons;
		  }
		
		pthread_wait_np();
      }
}

void initHCTLControlTask()
{
   struct sched_param params;  
   pthread_attr_t att;
   hrtime_t now;

   pthread_attr_init (&att);

   if (pthread_create(&HCTLControlTaskHandle, &att, HCTLControl, NULL))
    {
      printk("pthread_create failed\n"); 
    }

   params.sched_priority = 2;
    

   pthread_setschedparam(HCTLControlTaskHandle, 3, &params);

   pthread_setfp_np(HCTLControlTaskHandle,1);

   now = gethrtime();

   pthread_make_periodic_np(HCTLControlTaskHandle,now,PERIOD_HCTL_CONTROL_TASK_NANO);
}

void hctlCleanUp(void)
{  
  pthread_delete_np(HCTLControlTaskHandle);
}
	
void hctlInit( void )
{
  makeIOPerm();

  globalState = (volatile Global_State_T *)  
	mbuff_alloc_patch(GlobalStateAddr,
					  sizeof(Global_State_T));
  

  if (globalState==0)
	printk("mbuff_alloc failed (globalState)\n");
  
  // reset the global state
  currentRightSpeedCons = 0;
  globalState->rightSpeedCons = 0;
  
  currentLeftSpeedCons = 0;  
  globalState->leftSpeedCons = 0;
 
  

  
  initHCTL();
//  setAcc(STARTUP_ACCELERATION);
  
//  setMode();
//  hctlSetMotorSpeed(0,0);

  initHCTLControlTask();

}


char hctlGetRightPWM()
{
  char res;
  read_pwm(2,&res);
  return res;
}

char hctlGetLeftPWM()
{
  char res;
  read_pwm(1,&res);
  return res;
}



