#ifndef __I2CPERSERVER_H__
#define __I2CPERSERVER_H__

#include <pthread.h>
#include "events.h"

/***************** Structures Elementaires ***************/
typedef struct periodicTask 
{
  unsigned char waitedValue; 
  unsigned char slave;
  unsigned char mask;
  unsigned char operation;

  int Period;
  
  Event endEvent;

  struct periodicTask* next;
} periodicTask;

typedef struct slaveStruct
{
  unsigned char slave_addr; 

  int periodMin;
  periodicTask * taskList;

  pthread_t slaveThreadId;
  pthread_mutex_t slave_mutex;
} slaveStruct;

/*********************************************************/

extern periodicTask *  createPeriodicAcquisition(unsigned char, unsigned char, unsigned char, int);
extern periodicTask *  createPeriodicAcquisitionIsDifferent(unsigned char slave, unsigned char value, unsigned char mask, int Period);
extern Event* i2c_getEvent(periodicTask *);
extern void deletePeriodicAcquisition(periodicTask *);
extern void perServer_initModule();
extern void perServer_cleanUpModule();
#endif












