#ifndef COLLISION_SOLUTION_H
#define COLLISION_SOLUTION_H

#include "robot_geometry.h"

/*   POSITION des capteurs
         1
         _
       7| |8
        | |
        | |
  3_____| |______4
 |______   _______|
  5     | |      6
        | |
        | |
       9|_|10
         2


*/

#define COLLI_CAPT_FRONT 	COLLI_FRONT
#define COLLI_CAPT_FRONT_L         COLLI_FRONT_L
#define COLLI_CAPT_FRONT_R        COLLI_FRONT_R
#define COLLI_CAPT_REAR 	COLLI_REAR
#define COLLI_CAPT_REAR_L 	COLLI_REAR_L
#define COLLI_CAPT_REAR_R 	COLLI_REAR_R
#define COLLI_CAPT_RIGHT_F          COLLI_RIGHT_F
#define COLLI_CAPT_RIGHT_R         COLLI_RIGHT_R
#define COLLI_CAPT_LEFT_F 	COLLI_LEFT_F
#define COLLI_CAPT_LEFT_R 	COLLI_LEFT_R

#define OK 	0
#define ERROR -1
#define NO_COLLISION_ADDED_BEFORE_GET_SOLUTION 2  /* get solution call before CollisionDetected */
#define NO_SOLUTION_AVAILABLE 3/* no solution computed or no solution found */

void collision_initModule();
void CollisionDetected(int captor, double Robotx, double Roboty, double Robottheta);
int   CollisionGetSolution(double *speedR, double *speedL, double *distToRun);
void CollisionSetParameters(double speed, double reducedFactor, double distance);
#endif
