#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>

#ifndef DEBUG_MODULE_NAME 
#error "You have to set the DEBUG_MODULE_NAME before including debug.h !!!"
#endif

#define LEVEL_FATAL       0
#define LEVEL_ERROR     1
#define LEVEL_WARNING  2
#define LEVEL_INFO1        3
#define LEVEL_INFO2        4
#define LEVEL_INFO3        5
#define LEVEL_DEBUG1        6
#define LEVEL_DEBUG2        7
#define LEVEL_DEBUG3        8

#ifdef DEBUG
#define DEBUG_PRINTF(MODULE,...) do { \
                                      printf("[%s] [%s - line %d] "," " #MODULE " ", __FILE__, __LINE__); \
                                      printf(__VA_ARGS__); \
                                    } while (0)
#else
#define DEBUG_PRINTF(MODULE,...)
#endif //DEBUG

#ifdef DEBUG_L
#define DEBUG_LEVEL_PRINTF(LEVEL,MODULE,...) do { \
                                      if (LEVEL <= DEBUG_LEVEL) \
                                           { \
                                               printf("[%s] [%s - line %d] "," " #MODULE " ", __FILE__, __LINE__); \
                                               printf(__VA_ARGS__); \
                                           } \
                                    } while (0)
#else
#define DEBUG_LEVEL_PRINTF(LEVEL,MODULE,...)
#endif // DEBUG_L

#define debug_printf(...) DEBUG_PRINTF(__VA_ARGS__)
#define debug_level_printf(...) DEBUG_LEVEL_PRINTF(__VA_ARGS__)

#endif // __DEBUG_H__
