#ifndef _FLAG_LIB_
#define _FLAG_LIB_

#include "robot_geometry.h"


/* fonctions de depose des drapeau */
/* sort le bras si necessaire */
void prepareFlag(int flagnbr);
/* rentre le bras si necessaire */
void rentreFlag(int flagnbr);
void rentreAllFlag();
void rentreBrasOut(); /* attention si on appelle plusieurs fois prepareFlag, car bras out contient juste le dernier bras sorti */
/* lache le drapeau */
void dropFlag(int flagnbr);
/* lache le drapeau et dit que planete est faite */
void dropFlagOnPlanet(int flagnbr, int planetnbr);
/* return TRUE si le drapeau n'a pas ete utilis */
int  isFlagAvailable(int flagnbr);
/* return TRUE si le drapeau est au dessus d'une planete */
int  isFlagOnPlanet(int flagnbr,int planetnbr);

/* same functions but with bras instead of flagnbr*/
void PrepareBras(Bras *bras);
void DropFlagWithBras(Bras * bras);
void RentreBras(Bras * bras);
int  IsBrasAvailable(Bras * bras);
int IsBrasOnPlanet(Bras* bras,Objectif *planet);

void SetPlanetDone(Objectif * planet);
void PlanetIsDone(int nbrplanet);
int IsPlanetDone(int nbrplanet);

/* get first and next bras usable on a planet */
/* return NULL if no more bras, GetFirstBras must be called before GetNextBras */
Bras* GetFirstBras(Objectif * planet);
Bras* GetNextBras(Objectif * planet);
Bras* GetNearestBras(Objectif * planet); /* le bas qui minimise la rotation du robot */

#endif
