#ifndef __I2C_MAPPING_H__
#define __I2C_MAPPING_H__

#define NB_I2C_SLAVES 5

#define I2C_SLAVE_ADDRESS_1 0x3E
#define I2C_SLAVE_ADDRESS_2 0x20
#define I2C_SLAVE_ADDRESS_3 0x27
#define I2C_SLAVE_ADDRESS_4 0x25
#define I2C_SLAVE_ADDRESS_5 0x24


static unsigned char I2C_SLAVE_ADDRESS[NB_I2C_SLAVES] = {I2C_SLAVE_ADDRESS_1,
						            I2C_SLAVE_ADDRESS_2,
                                                                                                  I2C_SLAVE_ADDRESS_3,
                                                                                                  I2C_SLAVE_ADDRESS_4,
						            I2C_SLAVE_ADDRESS_5
                                                                                                  };

#define I2C_CARD_1_ID 0
#define I2C_CARD_2_ID 1

#define I2C_ARM_MOTOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_ARM_MOTOR_BIT 1

#define I2C_BIG_STAR_PMI_HOOK_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_BIG_STAR_PMI_HOOK_BIT 0

//#define I2C_ARM_HOOK_SLAVE I2C_SLAVE_ADDRESS_1
//#define I2C_ARM_HOOK_BIT 2

#define I2C_INITHCTL_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_INITHCTL_BIT 7

#define I2C_STARTJACK_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_STARTJACK_BIT 4 

#define I2C_ELECTRO_SLAVE I2C_SLAVE_ADDRESS_2

#define I2C_FRONT_BUMPER_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_FRONT_BUMPER_BIT 0
							 
#define I2C_FRONT_BUMPER_LEFT_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_FRONT_BUMPER_LEFT_BIT 7
							 
#define I2C_FRONT_BUMPER_RIGHT_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_FRONT_BUMPER_RIGHT_BIT 6
							 
#define I2C_REAR_BUMPER_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_REAR_BUMPER_BIT 1
							 
#define I2C_REAR_BUMPER_RIGHT_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_REAR_BUMPER_RIGHT_BIT 4
							 
#define I2C_REAR_BUMPER_LEFT_SLAVE I2C_SLAVE_ADDRESS_4
#define I2C_REAR_BUMPER_LEFT_BIT 5
							 
#define I2C_LEFT_LINE_SENSOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_LEFT_LINE_SENSOR_BIT 5

#define I2C_RIGHT_LINE_SENSOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_RIGHT_LINE_SENSOR_BIT 6

#define I2C_12V_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_12V_BIT 6

#define I2C_12V_PRESENCE_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_12V_PRESENCE_BIT 1

#define I2C_SERVOS_SLAVE I2C_SLAVE_ADDRESS_5

//#define I2C_MOTOR_STATUS_SLAVE I2C_SLAVE_ADDRESS_6+1
//#define I2C_MOTOR_CMD_SLAVE I2C_SLAVE_ADDRESS_6

#define ELECTRO_ARM 1
#define ELECTRO_RIGHT_PMI 7
#define ELECTRO_LEFT_PMI 6
#define ELECTRO_REAR_LEFT_FLAG 2
#define ELECTRO_REAR_RIGHT_FLAG 3
#define ELECTRO_FRONT_LEFT_FLAG 4
#define ELECTRO_FRONT_RIGHT_FLAG 5
#define ELECTRO_START_MOTOR_ARM 0

#define MOTOR_ARM 0
#define MOTOR_ARM_UP 0

#endif // __I2C_MAPPING_H__

