#ifndef __LOG_H__
#define __LOG_H__

#include <errno.h>
#include <stdarg.h>

#define LOG_DEBUG

#ifdef LOG_DEBUG
#define LOG_FILENAME "trajectory.log"
extern FILE*fptr1;
#endif

static void  openLog()
{
#ifdef LOG_DEBUG
  if (!fptr1)
    {
      fptr1=fopen(LOG_FILENAME,"a");
      if (!fptr1)
	printf("********************* ERREUR OUVERTURE FICHIER DE LOG (%s) *******************************\n", strerror(errno));
    }
#endif
}

#ifdef LOG_DEBUG 
#define printLog(...) do { \
                                     if (fptr1) \
                                        { \
                                          fprintf(fptr1, __VA_ARGS__); \
                                          fflush(fptr1); \
                                        } \
                                 } while (0)
#else
#define    printLog(...) 
#endif                 
                                   
#if 0
static void printLog(char *fmt, ...)
{
#ifdef LOG_DEBUG      
  va_list argp;
  
  if (fptr1)
    {
      va_start(argp, fmt);
      fprintf(fptr1, fmt, argp);
      va_end(argp);
      fflush(fptr1);
    }
#endif
}
#endif

static void closeLog()
{
#ifdef LOG_DEBUG      
  fclose(fptr1);
#endif
}

#endif
