#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include "events.h"
#include "periodServer.h"
#include "i2cManager.h"
#include "Kalman.h"
#include "shared.h"
#include "kalman_fifo.h"
#include "interprete_kalman.h"
#include "projet_kalman.h"
#include "robot_geometry.h"
#include "pthread.h"
#include "geometrieKalman.h"


#include "debug.h"
//#define DEBUG_MODULE_NAME KALMAN

#define FIFO 1

/***************** Variables globales  *******************/

 periodicTask* LeftLineSensor;
 Event* LeftLineEvent;

 periodicTask* RightLineSensor;
 Event* RightLineEvent;
 
 Event Line; //( ou de gauche ou de droite )
  pthread_mutex_t fifo_mutex;
 //P-e un mutex sur la fifo pour quand odometre
 
pthread_t LineDetectorThreadId;
pthread_t OdometreThreadId;
pthread_t ComputeThreadId;
 
/*volatile*/ struct kalman_fifo * myfifo;    //la fifo

double memodo1;
double memodo2;


//------------------------------------------------------------------
//   methodes pour la fifo
//------------------------------------------------------------------


int write_fifo (double d)
{

 putfifo(myfifo,(void *)&d, sizeof(double));

 return 1;

}


double readFifo(){
 
  double d;
  readfifo(myfifo,(void *)&d, sizeof(double));

 return d;
}

void openFIFO(){
  myfifo=createFifo(1000);


}

/************ Initialisation du serveur de detection de ligne blanche **********/

void leftLineCallback(Event* event)
{
  printf("Callback left line...\n");
pthread_mutex_lock(&fifo_mutex);
  write_fifo(3);
  write_fifo(2);
  pthread_mutex_unlock(&fifo_mutex);

}

void rightLineCallback(Event* event)
{
  printf("Callback left line...\n");
pthread_mutex_lock(&fifo_mutex);
  write_fifo(3);
  write_fifo(1);
 pthread_mutex_unlock(&fifo_mutex);
}

void anyLineCallback(Event* event)
{
  int n=0;
  printf("Callback any line...\n");
  //recherche du numero du capteur

  while(evenements[n]!=event) n++;

  pthread_mutex_lock(&fifo_mutex);
  write_fifo(3);
  write_fifo(n);
  pthread_mutex_unlock(&fifo_mutex);

}


#if 0
void * LineDetectorThread (void * arg)
{    

  orEvents(LeftLineEvent, RightLineEvent, &Line);
 
   while (1)
   {
  
     printf("attente d'evenement ligne \n");
     waitEvent(&Line);

     if (Line.signalingEvent == LeftLineEvent)
      {
pthread_mutex_lock(&fifo_mutex);
 write_fifo(3);
 write_fifo(2);
       pthread_mutex_unlock(&fifo_mutex);
      }
     else
      {
pthread_mutex_lock(&fifo_mutex);
 write_fifo(3);
 write_fifo(1);
       pthread_mutex_unlock(&fifo_mutex);
      }
     
   }
}
#endif


void ResetOdo(){
  memodo1=0;
  memodo2=0;
}

void * OdometreThread (void * arg)
{
  double odo1,odo2;

  //ici, on ajoute un bout de machin qui fait que odo1 et odo2 
  //representent maintenant l'ecart entre la nouvelle position des 
  //points de contact des roues et la position qu'ils avaient 
  //lors du dernier appel de cette fonction




  odo1=globalState->rightLength-memodo1;
  odo2=globalState->leftLength-memodo2;

  memodo1=globalState->rightLength;
  memodo2=globalState->leftLength;

 
  while(1){

    odo1=globalState->rightLength-memodo1;
    odo2=globalState->leftLength-memodo2;

  memodo1=globalState->rightLength;
  memodo2=globalState->leftLength;



  if(odo1!=0 || odo2!=0){
pthread_mutex_lock(&fifo_mutex);
    write_fifo(2);
    write_fifo(odo1*K);
    write_fifo(odo2*K);
  pthread_mutex_unlock(&fifo_mutex); 

  }
  usleep(10000); //tous les 1/100 secondes
  }


}

void lineServer_initModule() 
{
  RightLineSensor  = createPeriodicAcquisition(I2C_LEFT_LINE_SENSOR_SLAVE, 0 , 1 << I2C_LEFT_LINE_SENSOR_BIT, 5000);
  LeftLineSensor  = createPeriodicAcquisition(I2C_RIGHT_LINE_SENSOR_SLAVE, 0 , 1 << I2C_RIGHT_LINE_SENSOR_BIT, 5000);

  RightLineEvent = i2c_getEvent(LeftLineSensor);
  LeftLineEvent = i2c_getEvent(RightLineSensor);


  createCallback(RightLineEvent,rightLineCallback);

  createCallback(LeftLineEvent,leftLineCallback);


	/* if (0)
   {
	debug_printf(DEBUG_MODULE_NAME,"Probleme avec la FIFO \n"); 
        exit (0);	
   }
	*/
 
 
  //  pthread_create(&LineDetectorThreadId,NULL,LineDetectorThread,NULL); 




}



void lineServer_initModule2() 
{
  int i;
  for(i=0 ; i< NB_CAPT_LIGNS ; i++){
    printf("+");
    lineSensor[i]= createPeriodicAcquisition(line_sensor_slave[i], 0 , 1 << line_sensor_bit[i], 15000);
  }
 for(i=0 ; i< NB_CAPT_LIGNS ; i++){
  evenements[i]=i2c_getEvent(lineSensor[i]);
 }

 for(i=0 ; i< NB_CAPT_LIGNS ; i++){
 createCallback(evenements[i],anyLineCallback);
 }


}





void * ThreadDeCalcul (void *arg) 
{
  double d;
  void * buff;
  int size;


  while(1){
    size=sizeof(double);
    buff=(void *)&d;
    
   readfifo(myfifo,buff,size);

   interprete_kalman(d);
  }


}




/***************** Lancement et Arret *******************/

void Kalman_initModule()
{
  debug_printf(DEBUG_MODULE_NAME,"Initializing Kalman \n");

 printf("Initializing Kalman...\n");

 openFIFO();
 pthread_mutex_init(&(fifo_mutex),NULL);


 // Initialisation du canal ( Positionnement ) 

pthread_mutex_lock(&fifo_mutex);   
  write_fifo(1.);
  write_fifo(-200.);
  write_fifo(1050.);
  write_fifo(0.);
  write_fifo(10.);
  write_fifo(0.1);
pthread_mutex_unlock(&fifo_mutex);
 pthread_create(&OdometreThreadId,NULL,OdometreThread,NULL); 

  lineServer_initModule2();


  pthread_create(&ComputeThreadId,NULL,ThreadDeCalcul,NULL) ;

  while(kalman_initialise!=1){
    usleep(100);
  }


}

void Kalman_cleanUpModule()
{
  
  deletePeriodicAcquisition(LeftLineSensor);
  deletePeriodicAcquisition(RightLineSensor);
	
  pthread_cancel (LineDetectorThreadId);
  pthread_cancel(OdometreThreadId);

 pthread_mutex_destroy(&(fifo_mutex));
 
 debug_printf(DEBUG_MODULE_NAME,"Cleaning Kalman\n");
}

void Kalman_setPosition(double x,double y,double alpha,double erreur_xy,double erreur_alpha){


  pthread_mutex_lock(&fifo_mutex);
  write_fifo(4);
  write_fifo(x);
  write_fifo(y);
  write_fifo(alpha);
  write_fifo(erreur_xy);
  write_fifo(erreur_alpha);
  pthread_mutex_unlock(&fifo_mutex); 


};


void Kalman_setPosition_now_unsafe(double x,double y,double alpha,double erreur_xy,double erreur_alpha){



   interprete_kalman(4);
   interprete_kalman(x);
   interprete_kalman(y);
   interprete_kalman(alpha);
   interprete_kalman(erreur_xy);
   interprete_kalman(erreur_alpha);
  


};











