#ifndef __KALMAN_K_H__
#define  __KALMAN_K_H__

#include <pthread.h>
#include "events.h"


/***************** Structures Elementaires ***************/

/*
typedef struct periodicTask 
{
  unsigned char waitedValue; 
  unsigned char slave;
  unsigned char mask;

  int Period;
  
  Event endEvent;

  struct periodicTask* next;
} periodicTask;

typedef struct slaveStruct
{
  unsigned char slave_addr; 

  int firstTime;
  int periodMin;
  periodicTask * taskList;

  pthread_t slaveThreadId;
  pthread_mutex_t slave_mutex;
} slaveStruct;
*/
/*********************************************************/

void * LineDetectorThread (void * arg);
      
void * OdometreThread (void * arg);
void * ThreadDeCalcul (void *arg) ;
void Kalman_initModule();
void Kalman_cleanUpModule();
void Kalman_setPosition(double x,double y,double alpha,double erreur_xy,double erreur_alpha);
void Kalman_setPosition_now_unsafe(double x,double y,double alpha,double erreur_xy,double erreur_alpha);
void ResetOdo();

extern double getx();
extern double gety();
extern double get_alpha();



/*

 ^ y    /
 |     /            +----------
 |    /--           |
 |   /| \  alpha    |
 |  /    \          |
 | /      |         |     
 |/       |  x  +---+
 +----------->  |          
                |    
                |  
                +---+
                    |	   
                    |
                    |
                    |
          (0,0) --> +----------
    (origine du repere)

les mesures sont en mm et en rad



                  X
         ^       /     
         |      / -- 
         |     /  |\       
   /-----------\    \  cette fleche (si si c'est une fleche)
  /     ===  /  \    \  donne le sens d'orientation de l'angle alpha  donner pour le capteur
 /       |  /    \    |    
 |       | /     |    |  
 |       |/      |    |  
 |       +-------|-----> 
 |               |
 |               |
 \               /
  \     ===     /
   \-----------/
  

*/





#endif












