
#ifndef _BUILDTABLINE__
#define _BUILDTABLINE__

#include <stdlib.h>
#include <stdio.h>
#include <math.h>

struct point{
  double x;
  double y;
};


struct ligne2p{

  struct point p1;
  struct point p2;

};

double *** preTableauDesLignes;

struct ligne2p * tablig2p;

//----------------------------------------
//    quelques parametres
//----------------------------------------

double tailleXmin=0;  //en mm
double tailleXmax=3000;

double tailleYmin=0;
double tailleYmax=2100;


//les parametres de division
double numdivx=80;
double numdivy=40;

//le parametre de precision
double precision=0.1;

int currentLine=0;

int nbLignes=0;
void addline(double x1,double y1,double x2,double y2){
  tablig2p[currentLine].p1.x=x1;
  tablig2p[currentLine].p1.y=y1;
  tablig2p[currentLine].p2.x=x2;
  tablig2p[currentLine].p2.y=y2;
  currentLine++;

}

void creationTableauDesLignes2p(){
  nbLignes=24;

  tablig2p=(struct ligne2p * )malloc( nbLignes*sizeof(struct ligne2p));






addline(-100,1050,375,1050);
addline(690,1050,1500,1050);
addline(1500,1050,2337,1050);
addline(2606,1050,3000,1050);
addline(1500,-1000,1500,215);
addline(1500,485,1500,1050);
addline(1500,1050,1500,1690);
addline(1500,1895,1500,3100);
addline(660,3100,660,1895);
addline(660,215,660,-1000);
addline(2370,-1000,2370,215);
addline(2370,3100,2370,1895);

 /* apres c'est l'ellipse

addline(1230,1770,965,1695);
addline(905,1650,675,1475);
addline(545,1223,612,1385);

addline(1230,330,965,405);
addline(905,450,675,625);
addline(545,877,612,715);

addline(1770,1770,2035,1695);
addline(2095,1650,2325,1475);
addline(2455,1223,2388,1385);

addline(1770,330,2035,405);
addline(2095,450,2325,625);
addline(2455,877,2388,715);


 */



}

double isInEllipse(struct ligne2p * l, double x, double y){

  double dx1,dy1,d1;
  double dx2,dy2,d2;
  double dx3,dy3,d3;
  double r;
  //----------------------
  dx1=(l->p1.x-l->p2.x);
  dx1=dx1*dx1;

  dy1=(l->p1.y-l->p2.y);
  dy1=dy1*dy1;

  d1=dx1+dy1;

  //----------------------

  dx2=(l->p1.x-x);
  dx2=dx2*dx2;

  dy2=(l->p1.y-y);
  dy2=dy2*dy2;
  d2=dx2+dy2;

  //----------------------
   dx3=(l->p2.x-x);
  dx3=dx3*dx3;

  dy3=(l->p2.y-y);
  dy3=dy3*dy3;
  d3=dx3+dy3;
  //----------------------

  r=(sqrt(d2)+sqrt(d3))/sqrt(d1);
  if(r<1) printf("probleme !!\n\n%f %f\n",d2+d3,d1);
  return r-1;

}
//--------------------------------------------------
//  calcul a b c
//--------------------------------------------------


double calcula(struct ligne2p * l){
  return l->p1.y-l->p2.y;
}
double calculb(struct ligne2p * l){
  return -(l->p1.x-l->p2.x);
}
double calculc(struct ligne2p * l){
  return l->p2.y*l->p1.x-l->p2.x*l->p1.y;
}


void creationTableauDesLignes(){
  int i,j,k;
  double atemp;
  double btemp;
  double ctemp;
  int numLigne;
  double dist;
  
  double x;
  double y;
  
  //printf("creation tableau des lignes 2p\n");

  creationTableauDesLignes2p();

 preTableauDesLignes=(double ***)malloc(numdivx*sizeof(double**));
  for(i=0 ; i<numdivx ; i++){
    preTableauDesLignes[i]=(double **)malloc(numdivy*sizeof(double*));
    for(j=0 ; j<numdivy ; j++){
      preTableauDesLignes[i][j]=(double *)malloc(3*sizeof(double));
    }
  }


  //printf("taille memoire : %d\n",(int)(numdivx*numdivy*3*sizeof(double)));

 for(i=0 ; i<numdivx ; i++){
    for(j=0 ; j<numdivy ; j++){
      //on passe en revue toutes les lignes

      x=(((double)i+0.5)*(tailleXmax-tailleXmin)/(double)numdivx)+tailleXmin;
      y=(((double)j+0.5)*(tailleYmax-tailleYmin)/(double)numdivy)+tailleYmin;
      numLigne=0;
       

      for(k=0 ; k<nbLignes ; k++){
	
	dist=isInEllipse(&tablig2p[k],x,y);
	//printf("x=%f y=%f dist=%f ligne=%d \n",x,y,dist,k);
       
	if(dist<precision) {
	
	  numLigne++;
	  atemp=calcula(&tablig2p[k]);
	  btemp=calculb(&tablig2p[k]);
	  ctemp=calculc(&tablig2p[k]);
	}

      }
      
      if(numLigne==1){
	
	preTableauDesLignes[i][j][0]=atemp;
	preTableauDesLignes[i][j][1]=btemp;
	preTableauDesLignes[i][j][2]=ctemp;
	

      }
      else{
	
	
	preTableauDesLignes[i][j][0]=0;
	preTableauDesLignes[i][j][1]=0;
	preTableauDesLignes[i][j][2]=0;
	
      }


    }
}


}

#endif







