
#include <stdio.h>
#include <stdlib.h> 
#include "/opt/khepera/khepera-remote-2.0/include/serial_io.h"
#include "/opt/khepera/khepera-remote-2.0/include/I.v.0.0.h"
#include "/opt/khepera/khepera-remote-2.0/include/khep_physical_robot.h"
#include <math.h>
#include <unistd.h>   
#include "projet_kalman.h"

serial_t serial_1;

int16 vright,vleft; //vitesses angulaires 

u_int16 n_val1,n_val2,n_val3,n_val4,n_val5,n_val6,n_val7,n_val8;

int32 p_right, p_left;


 double vr=0;
 double vd=0;


double p_right_old;
double p_left_old;

double ks=5.;
double v_consigne;
double d_consigne;



double k1=5.;
double k2=0;
double k3=0;


double xm=0;
double ym=0;

double xerr=0;
double yerr=0;

double intxerr=0;
double intyerr=0;

double vmax=400;

double getDistOdo(){

  double res,dpr,dpl;

  
  H(&serial_1,&p_left, &p_right);

  dpr=(double)(p_right-p_right_old);
  dpl=(double)(p_left-p_left_old);


  res=(dpr+dpl)/2.*0.08;

 
  p_right_old+=(dpr+dpl)/2.;
  p_left_old+=(dpl+dpr)/2.;
  return res;

};


double getAngleOdo(){

 double res,dpr,dpl;

  
  H(&serial_1,&p_left, &p_right);

  dpr=p_right-p_right_old;
  dpl=p_left-p_left_old;


  res=((dpr-dpl)*0.08)*0.001/((double)D_BASE);

 
 p_right_old+=(dpr-dpl)/2.;
  p_left_old+=(dpl-dpr)/2.;
  printf("angle odo :%f\n",res);

  return res;

};







void consigne_vitesse_droite_rotation(double vd, double vr){

  vright=vd+vr*500*D_BASE;
  vleft=vd-vr*500*D_BASE;

  D(&serial_1,vright,vleft);


}


double mesure_gauche(){
  
  N(&serial_1,&n_val1,&n_val2,&n_val3,&n_val4,&n_val5,&n_val6,&n_val7,&n_val8);
  //printf("mesure gauche %d\n",n_val2);
  return n_val2;
  
  
  
}

double get_d(u_int16 mesure){

  return (24.)+17.-((double)mesure/1024.)*24.;

}


void suivre_a_gauche(){
  double d;
double mesure_g;

  mesure_g=mesure_gauche();
  d=get_d(mesure_g);
  //printf("d=%f\n",d);
  vd=v_consigne;
  vr=ks*(d_consigne-d);
  consigne_vitesse_droite_rotation(vd,vr);
  //printf("consigne vitesse %f rotation %f",vd,vr);


}

double get_k1(double phi,double wn,double v){

  return (wn*wn*sin(phi)/v)/1000;

}


/*


int main (int argc, char *argv[])
{
  double t;

  double phi;
  double wn;
  double v;

  phi=(double)atoi(argv[1])/100.;
  wn=(double)atoi(argv[2])/100.;
  v=(double)atoi(argv[3])/100.;
  d_consigne=(double)atoi(argv[4])/100.;

  //printf ("\n phi %f, wn %f \n",phi,wn);

  v_consigne=v;
  ks=get_k1(phi,wn,v);

  serial_1.dbg_serial= 1;
  serial_1.trc_serial= 1;
  serial_init_env(&serial_1);
  G(&serial_1,0,0);
  //printf("coucou\n");
  initKalman();
  //printf("coucou\n");

  for(t=0;;t+=1)
    {
      //printf("suivre a gauche\n");
      suivre_a_gauche();
      //printf("position update\n");
      positionUpdate();
      printf("ecriture de x y z \n");
      printf("x=%f y=%f alpha=%f\n",getx(),gety(),get_alpha());
      print_erreur();
      //fusionMesureAngle(0.01,0.01);
     
    }
}


*/




//---------------------------------------------------------------------------------
//   test de validation
//---------------------------------------------------------------------------------

double x_(long t) {
  return 150;
  //return 1.*((double)100/1.)*sin((double)t/30.);
}

double y_ (long t) {
  return -150;
  //return 1.*((double)100/1.)*cos((double)t/60.);

}

 
double get_x_p (long t) {
  double temp;
  double dxerr=((x_(t)-xm))-xerr;
  intxerr+=(x_(t)-xm);
  temp=(k1*((x_(t)-xm))+dxerr*k2+intxerr*k3);
  xerr=(x_(t)-xm);
  printf("vx:=%f\n xconsigne:=%f\n",temp,x_(t));
  if(temp > vmax) temp=vmax;
  if(temp < -vmax) temp=-vmax;
  return temp;
}

double get_y_p (long t) {
  double temp;
  double dyerr=((y_(t)-ym))-yerr;
  intyerr+=(y_(t)-ym);
  temp=(k1*((y_(t)-ym))+dyerr*k2+intyerr*k3);
  yerr=(y_(t)-ym);
  printf("vy:=%f\n yconsigne:=%f\n",temp,y_(t));
 if(temp > vmax) temp=vmax;
  if(temp < -vmax) temp=-vmax;
  return temp;
}


void mesure_position () {
 
  double x,y,theta;
  
  positionUpdate();

  x=getx();
  y=gety();
  theta=get_alpha();

  xm=x+500.*D_BASE*cos(theta);
  ym=y+500.*D_BASE*sin(theta);

  printf("xm %f,ym%f\n",xm,ym);


}


void consigne_vitesse (double vx,double vy) {
  
  double theta;
  double cos_theta;
  double sin_theta;
  int16  vright,vleft;

  theta=get_alpha();
  cos_theta=cos(theta);
  sin_theta=sin(theta);

  //printf ("theta %f, cos %f, sin %f\n",theta,cos_theta,sin_theta);
 

  vright=(int16)((.25)*( (cos_theta-sin_theta)*vx+(cos_theta+sin_theta)*vy)/8.);
  vleft= (int16)((.25)*(-(cos_theta-sin_theta)*vy+(cos_theta+sin_theta)*vx)/8.);
  
  //printf("vright %d , vleft %d\n",vright,vleft);


  D(&serial_1,vleft,vright);

}


void aller_a(){

 consigne_vitesse(get_x_p(0),get_y_p(0));

}

int main (int argc, char *argv[])
{
  double t;

  double phi;
  double wn;
  double v;
  /*
  phi=(double)atoi(argv[1])/100.;
  wn=(double)atoi(argv[2])/100.;
  v=(double)atoi(argv[3])/100.;
  */
  phi=0.75;
  wn=20.;
  v=10.;
  
  //d_consigne=(double)atoi(argv[4])/100.;

  d_consigne=37.;

  //printf ("\n phi %f, wn %f \n",phi,wn);

  v_consigne=v;
  ks=get_k1(phi,wn,v);

  serial_1.dbg_serial= 1;
  serial_1.trc_serial= 1;
  serial_init_env(&serial_1);
  G(&serial_1,0,0);
  initKalman(0,0,0,0.1,1.);

 for(t=0;t<100;t++)
    {
      consigne_vitesse (200,0);
      //printf("position update\n");
      positionUpdate();
      printf("ecriture de x y z \n");
      printf("aller tout droit x=%f y=%f alpha=%f\n",getx(),gety(),get_alpha());
      print_erreur();
    }
 
 /*
 for(t=0;t<100;t++)
    {
      //printf("suivre a gauche\n");
      consigne_vitesse (0,200);
      //printf("position update\n");
      positionUpdate();
      printf("ecriture de x y z \n");
      printf("aller tout droit x=%f y=%f alpha=%f\n",xm,ym,get_alpha());
      print_erreur();
    }
 */
 
  for(t=0;t<20;t++)
    {
      //printf("suivre a gauche\n");
      suivre_a_gauche();
      //printf("position update\n");
      positionUpdate();
      printf("ecriture de x y z \n");
      printf("suivre a gauche 1 x=%f y=%f alpha=%f\n",getx(),gety(),get_alpha());
      print_erreur();
    }

 

 
 for(t=0;t<50;t++)
    {
      //printf("suivre a gauche\n");
      suivre_a_gauche();
      //printf("position update\n");
      positionUpdate();
      printf("ecriture de x y z \n");
      printf(" suivre a gauche 2 x=%f y=%f alpha=%f\n",getx(),gety(),get_alpha());
      print_erreur();
      fusionMesureAngle(0.01,1.);
    }
 

  for(t=0;;t++)
    {
     
      aller_a();
      //printf("position update\n");
      mesure_position();
      printf("ecriture de x y z \n");
      printf("aller a 150 150 x=%f y=%f alpha=%f\n",xm,ym,get_alpha());
      print_erreur();
      
    }



}


















































