
#include "matrix.h"
#include <math.h>
#include <unistd.h>
#include <stdio.h>
 #include <stdlib.h>


//-----------------------------------------------------------------------
//    les appels "systems"
//-----------------------------------------------------------------------

//extern float getAngleGonio(); //angle en radian de la dernire mesure. le 0 est devant le robot
//extern int getBaliseGonio(); //0 si aucune balise
//extern int getLine(); //1 si le robot passe sur une ligne 0 sinon
/*extern*/ double getAngleOdo(){
  return (float)0.01;
}; 
/*extern*/ double getDistOdo(){
  return (float)0.01;
}; 


float odoNoiseX=0.0001;
float odoNoiseY=0.0001;
float odoNoiseAlpha=0.0001;

float gonioNoise=0.1;

#define ODOMETRE 1
#define GONIO 2
#define GONIO1 3
#define GONIO2 4
#define GONIO3 5

#define FALSE 1;
#define TRUE 0;


int typeDeMesure=ODOMETRE;

//-----------------------------------------------------------------------
//  variables gloabales
//-----------------------------------------------------------------------

//on utilise une architecture simplifie
//toutes les variables importantes sont globales


Mtx_Matrix* position; //(vecteur colonne 3 lignes)
Mtx_Matrix* erreurPosition; //(3x3)
Mtx_Matrix* updatePosMatrix; 


Mtx_Matrix* jacobGonio;  //(vecteurligne 3 colones)
Mtx_Matrix* mesureGonio; //(1x1)
Mtx_Matrix* erreurGonio;

Mtx_Matrix* erreurOdo;

Mtx_Matrix* K; //gain de kalman

double xBalise1=0;
double yBalise1=0;

double xBalise2=1;
double yBalise2=0;

double xBalise3=-1;
double yBalise3=0;


double mesure1=0;
double mesure2=0;
double mesure3=0;

int alarue=0;

int gonio=GONIO1;

Mtx_Matrix * simulateMesureGonio();
//----------------------------------------------------------------------
// methode updatePosition
//----------------------------------------------------------------------

Mtx_Matrix* getErreurOdo(){
 
 
  set(erreurOdo,0,0,odoNoiseX);
  set(erreurOdo,1,1,odoNoiseY);
  set(erreurOdo,2,2,odoNoiseAlpha);

  return erreurOdo;

}


void getErreurGonio(){

 Mtx_DeleteMatrix(erreurGonio);
erreurGonio=Mtx_GetNewMatrix(1,1); //gain de kalman

 set(erreurGonio,0,0,0.01);


}

Mtx_Matrix *  getUpdatePosMatrix(double dl){ //dl est la longueur du pas en cours

  double x,y,a;
 

 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);


 set(updatePosMatrix,0,0,1);
 set(updatePosMatrix,1,1,1);
 set(updatePosMatrix,2,2,1);

 set(updatePosMatrix,2,0,-sin(a)*dl);
 //set(updatePosMatrix,0,2,-sin(a)*dl);

 set(updatePosMatrix,2,1,cos(a)*dl);
 //set(updatePosMatrix,1,2,cos(a)*dl);


  return updatePosMatrix;
}


void positionUpdate(){
  double x,y,a,l,b;
  Mtx_Matrix * temp1,*temp2,*temp3,*upm;

 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

 l= getDistOdo();
 b=getAngleOdo();

 //update de la premiere partie de l'erreur
 /*
 upm=getUpdatePosMatrix(l);

 temp1=Mtx_Transpose(upm);
 temp2=Mtx_Product(upm,erreurPosition);
 temp3=Mtx_Product(temp2,temp1);
 
 Mtx_DeleteMatrix(temp1);
 Mtx_DeleteMatrix(temp2);
 Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=temp3;
 */
 y=y+l*cos(a);
 x=x-l*sin(a);
 a=a+b;

 if(a>3.1415) {
   a=a-(2*3.1415);
   //printf("a>pi\n");
 }

 if(a<-3.1415) a=a+(2*3.1415);

 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,a);

 //update de la seconde partie de l'erreur

 temp1=Mtx_Sum(erreurPosition,getErreurOdo());
  Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=temp1;

 return;
}

//--------------------------------------------------------------------------
//   methode jesuisalarue
//--------------------------------------------------------------------------
void updateState();
Mtx_Matrix *  getMesureGonio();
void calculGain();
void calculJacobGonio();
void jeSuisALaRue(){
  
 
  //printf("declenchement de retrouvaille de position\n");
  // set(erreurPosition,0,0,15);
  //set(erreurPosition,1,1,15);
  //set(erreurPosition,2,2,0.2);



}


//------------------------------------------------------------------------
// methode calculJacobGonio
//------------------------------------------------------------------------

void calculJacobGonio(){
  double yp,xp,x,y,a,dmdx,dmdy,dmda;
 


 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);
 if(gonio==GONIO1){  
 xp=x-xBalise1;
 yp=y-yBalise1;
 
 }
if(gonio==GONIO2){  
 xp=x-xBalise2;
 yp=y-yBalise2;
 
 }
if(gonio==GONIO3){  
 xp=x-xBalise3;
 yp=y-yBalise3;


 
 }


 if((yp*yp+xp*xp)!=0){
   dmdx=-yp/sqrt(yp*yp+xp*xp);
   dmdy=xp/sqrt(yp*yp+xp*xp);
   dmda=-1;
   }


 else {
   // printf("probleme1\n");
return;
 }
  set(jacobGonio,0,0,dmdx);  //dm/dx
  set(jacobGonio,0,1,dmdy);
  set(jacobGonio,0,2,dmda);




  return ;
}

Mtx_Matrix * getMesureGonio(){


 if(gonio==GONIO1)  set(mesureGonio,0,0,mesure1);
 if(gonio==GONIO2)  set(mesureGonio,0,0,mesure2);
 if(gonio==GONIO3)  set(mesureGonio,0,0,mesure3);

  return mesureGonio;

}

//-----------------------------------------------------------------------
//  calcul du gain de kalman
//-----------------------------------------------------------------------

void calculGain(){

  Mtx_Matrix * temp1,*temp2,*temp3,*temp4,*temp5,*trjg;

  trjg=Mtx_Transpose(jacobGonio);
  temp1=Mtx_Product(erreurPosition,trjg);
  temp2=Mtx_Product(jacobGonio,erreurPosition);
  temp3=Mtx_Product(temp2,trjg);
  getErreurGonio();

  temp4=Mtx_Sum(temp3,erreurGonio); 
 

  //  temp1=Mtx_Sum(erreurPosition,tmp2);
  //Mtx_DeleteMatrix(erreurPosition);
  // Mtx_DeleteMatrix(tmp2);
  //erreurPosition=temp1;
  //verifier que temp2 est inversibe
  if(get(temp4,0,0)==0) {
	//mettre le gain  0;
	return;
  }
  
  //printf("coef de modification : %f\n",get(temp4,0,0));

  // printf("coucou\n");
  
  temp5=Mtx_Inverse(temp4);

  //printf("inversion reussie\n");

 Mtx_DeleteMatrix(K);
  K=Mtx_Product(temp1,temp5);

 Mtx_DeleteMatrix(temp1);
 Mtx_DeleteMatrix(temp2);
 Mtx_DeleteMatrix(temp3);
 Mtx_DeleteMatrix(temp4);
 Mtx_DeleteMatrix(temp5);
 Mtx_DeleteMatrix(trjg); 

 //printf("K:\n");
 //Mtx_MatrixPrint(K);
  return;

}

//------------------------------------------------------------------------
//   is on a line
//------------------------------------------------------------------------

void isOnALineY(double c,double betha,double d){ 
 
  Mtx_Matrix * M;
 //si la ligne a pour equation y=c
  //betha et d represente la position du capteur dans le repere local du robot

  double x,y,a,temp,xx,yy,aa,a_c,b_c,c_c,d_c,e_c,f_c;


  //premiere chose, on se place dans le repre local autours du capteur

 
 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

 
 x=x-sin(betha+a)*d;
 y=y+cos(betha+a)*d;

 yy=c-y;
 xx=0;
 aa=0;

 //deuxieme chose, on calcul la 

M= Mtx_Inverse(erreurPosition);
 a_c= get(M,0,0);
 b_c= get(M,1,1);
 c_c= get(M,2,2);
 d_c= get(M,1,0);
 e_c= get(M,2,0);
 f_c= get(M,2,1);



 temp=c_c*a_c-e_c*e_c;
 if(temp==0){
   //on verra plus tard
   return;

 } 

 xx=yy*(c_c*d_c-e_c*f_c)/temp;
 aa=yy*(a_c*f_c-e_c*d_c)/temp;

 //on actualise la position

 x=x+xx;
 a=a+aa;
 y=y+yy;
 

 //derniere chose, on revient dans le repere principal
 
 x=x+sin(betha+a)*d;
 y=y-cos(betha+a)*d;

 
 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,a);

 //on ajuste la matrice d'erreur position;
 
 
   set(M,1,1,10000);
 //set(M,1,0,1000000);
 //set(M,1,1,1000000);
 //set(M,2,1,1000000);
 //set(M,1,2,1000000);
 
 
Mtx_DeleteMatrix(erreurPosition); 
erreurPosition= Mtx_Inverse(M); 
 
Mtx_DeleteMatrix(M); 

 
 return;
}



void isOnALineX(double c,double betha,double d){ 
 
  Mtx_Matrix * M;
 //si la ligne a pour equation y=c
  //betha et d represente la position du capteur dans le repere local du robot

  double x,y,a,temp,xx,yy,aa,a_c,b_c,c_c,d_c,e_c,f_c;


  //premiere chose, on se place dans le repre local autours du capteur

 
 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

 
 x=x-sin(betha+a)*d;
 y=y+cos(betha+a)*d;

 yy=0;
 xx=c-x;
 aa=0;

 //deuxieme chose, on calcul la 
M= Mtx_Inverse(erreurPosition);
 a_c= get(M,0,0);
 b_c= get(M,1,1);
 c_c= get(M,2,2);
 d_c= get(M,1,0);
 e_c= get(M,2,0);
 f_c= get(M,2,1);
 

 temp=c_c*b_c-f_c*f_c;
 if(temp==0){
   //on verra plus tard
   return;

 } 

 yy=xx*(c_c*d_c-e_c*f_c)/temp;
 aa=xx*(b_c*e_c-f_c*d_c)/temp;

 //on actualise la position

 x=x+xx;
 a=a+aa;
 y=y+yy;
 

 //derniere chose, on revient dans le repere principal
 
 x=x+sin(betha+a)*d;
 y=y-cos(betha+a)*d;

 
 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,a);

 //on ajuste la matrice d'erreur position;
 
 //set(M,0,1,1000000);
 set(M,0,0,100000);
 //set(M,1,0,1000000);
 //set(M,2,0,1000000);
 //set(M,0,2,1000000);
 
 
 Mtx_DeleteMatrix(erreurPosition); 
 erreurPosition= Mtx_Inverse(M);

  
Mtx_DeleteMatrix(M); 
 
 return;
}


void simulLigne(double x,double y,double a){
  double yy,xx;

  yy=y+cos(1+a)*0.1;
  xx=x-sin(1+a)*0.1;

  //printf("coucou %f %f % \nf",(float)x,(float)y,(float)a);
  if(yy<(double)(2.01) && yy>(double)(1.99)){
    //printf("coucou");
    isOnALineY(2,1,0.1);
  }
  if(xx<(double)(0.01) && xx>(double)(-.01)){
    //printf("coucou");
    isOnALineX(0,1,0.1);
  }
  return ;
}

//------------------------------------------------------------------------
//   updateState 
//------------------------------------------------------------------------

void updateState(){

Mtx_Matrix * temp1,*temp2,*temp3,*temp4,*temp5,*temp6,*tempPosition,*tempErreurPosition;

 double a;
//------update de la position--------
//printf("getMesureGonio\n");
 temp1=getMesureGonio();
 //printf("calculJacobGonio\n");



 calculJacobGonio();
 //printf("calculGain\n");
 calculGain();
 //printf("mise a jour de l'etat\n");
 temp2=simulateMesureGonio();
 temp3=Mtx_Substract(temp1,temp2);

 a=get(temp3,0,0);
 if(a>3.1415) a=a-2*(3.1415);  //les mesures se font modulo pi
 if(a<-3.1415) a=a+2*3.1415;

 if(a<-0.02 || a>0.02){
   alarue++;
   if(alarue>10) alarue=10;
   //printf("a la rue\n");

 }else alarue-=2;

 if(alarue<0) alarue=0;
 if(alarue>2) jeSuisALaRue();

 set(temp3,0,0,a);
 //printf("erreurMesure");
 //Mtx_MatrixPrint(temp3);
 temp4=Mtx_Product(K,temp3);
 tempPosition=Mtx_Sum(position,temp4);
 Mtx_DeleteMatrix(position);
 position=tempPosition;

 Mtx_DeleteMatrix(temp2);
 Mtx_DeleteMatrix(temp3);
 Mtx_DeleteMatrix(temp4);


 //--------------update de l'erreur--------

 temp5=Mtx_Product(K,jacobGonio);
 temp6=Mtx_SubToIdent(temp5);
 tempErreurPosition=Mtx_Product(temp6,erreurPosition);
 Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=tempErreurPosition;
 Mtx_DeleteMatrix(temp5);
 Mtx_DeleteMatrix(temp6);


 return;

}


//-----------------------------------------------------------------------
// initKalman
//----------------------------------------------------------------------

void initKalman(){

position=Mtx_GetNewMatrix(3,1); //(vecteur colonne 3 lignes)
erreurPosition=Mtx_GetNewMatrix(3,3); //(3x3)

 set(erreurPosition,0,0,5);
 set(erreurPosition,1,1,5);
 set(erreurPosition,2,2,1);
jacobGonio=Mtx_GetNewMatrix(1,3); //(vecteurligne 3 colones)
mesureGonio=Mtx_GetNewMatrix(1,1); //(1x1)
erreurGonio=Mtx_GetNewMatrix(1,1);

erreurOdo=Mtx_GetNewMatrix(3,3);
 updatePosMatrix=Mtx_GetNewMatrix(3,3);

K=Mtx_GetNewMatrix(3,3);; //gain de kalman

 set(erreurGonio,0,0,gonioNoise);                                                  

mesure1=0;
 mesure2=0;
 mesure3=0;
 return;

}

//-----------------------------------------------------------------------
//   fonction de teste
//-----------------------------------------------------------------------

double simulMesure(double x, double y,double a){
  double xp,yp,m;

 if(gonio==GONIO1){  
 xp=x-xBalise1;
 yp=y-yBalise1;
 
 }
if(gonio==GONIO2){  
 xp=x-xBalise2;
 yp=y-yBalise2;
 
 }
if(gonio==GONIO3){  
 xp=x-xBalise3;
 yp=y-yBalise3;
 
 }

 m=-atan(xp/yp);

 if(xp>=0 && yp>0) m=3.14+m;
 if(xp<=0 && yp>=0) m=m-3.14;

 m=m-a;
 

 return m;

}
Mtx_Matrix * simulateMesureGonio(){
  double x,y,a;
  Mtx_Matrix * m;


 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

  m=Mtx_GetNewMatrix(1,1);
  
set(m,0,0,simulMesure(x,y,a));
 return m;


}

void printState(double x1,double y1,double a1){

  double x,y,a,xreel,yreel,areel;
 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

 xreel=x1;
 yreel=y1;
 areel=a1;



 // printf("x %f y %f a %f xreel %f yreel %f areel %f gonio %d\n", x,y,a,xreel,yreel,areel,gonio);

printf("%f %f %f %f %f %f %d\n", x,y,a,xreel,yreel,areel,gonio);
  return;

}
//------------------------------------------------------------------------
//   la boucle principale
//------------------------------------------------------------------------

int main(){
  Mtx_Matrix * temp;
  double x,y,a,ms,l,b;
  int i;
  int j;
  Mtx_ManagerInit();
  initKalman();
  set(position,1,0,1.5);
  set(position,0,0,1.0);
  set(position,2,0,0.1);

  

  x=1.1;
  y=1.5;
  a=0;
  i=0;
  //printf("A=[...\n");


  for(j=0;j<10000;j++){
	//calcul de mesure
	
	
	
	l=0.01;
	  b=0.01;

	y=y+l*cos(a);
	x=x-l*sin(a);
	a=a+b;

	if(a>3.1415) {
	  a=a-(2*3.1415);
	}
	
	if(a<-3.1415) a=a+(2*3.1415);

	//printf("x := %f\n",x);
	//printf("y := %f\n",y);

	//printf("mesure\n");
	if(i%3==0) gonio=GONIO1;
	if(i%3==1) gonio=GONIO1;
	if(i%3==2) gonio=GONIO1;
	i++;

	mesure1=simulMesure(x,y,a);
	mesure2=simulMesure(x,y,a);
	mesure3=simulMesure(x,y,a);

	mesure1=mesure1+(double)((rand()%100)-50)/(double)1000;
	mesure2=mesure2+(double)((rand()%100)-50)/(double)1000;
	mesure3=mesure3+(double)((rand()%100)-50)/(double)1000;

	positionUpdate();
	//Mtx_MatrixPrint(erreurPosition);
	simulLigne(x,y,a);
	//printf("mesure = %f\n",mesure1);
	temp=simulateMesureGonio();
	ms=get(temp,0,0);
	Mtx_DeleteMatrix(temp);
	//printf("erreurMesure avant update : %f\n",mesure1-ms);
	
	//printf("positionupdate\n");
       
	//printf("updateState\n");
	//Mtx_MatrixPrint(position);
	if(i%100==0) updateState();
	//printf("position apres update\n");
	//Mtx_MatrixPrint(position);
	//printf("erreur Position\n");
	//Mtx_MatrixPrint(erreurPosition);
	temp=simulateMesureGonio();
	ms=get(temp,0,0);
	Mtx_DeleteMatrix(temp);
	//printf("erreurMesure apres update : %f\n",mesure1-ms);
	printState(x,y,a);
	
  }

  // printf("];\n");

  return 1;



}
