

#ifndef __GEOMETRIE_KALMAN__
#define __GEOMETRIE_KALMAN__

#include "i2cMapping.h"
#include "shared.h"
#include "events.h"
#include "periodServer.h"

#define NB_CAPT_LIGNS 2

static int line_sensor_slave[NB_CAPT_LIGNS]={I2C_LEFT_LINE_SENSOR_SLAVE, I2C_LEFT_LINE_SENSOR_SLAVE };
static int line_sensor_bit[NB_CAPT_LIGNS]={ I2C_LEFT_LINE_SENSOR_BIT, I2C_RIGHT_LINE_SENSOR_BIT };


static double Rayon[NB_CAPT_LIGNS]={143,143};  //en mm
static double Angle[NB_CAPT_LIGNS]={1.78,-1.78}; //en rad


static Event * evenements[NB_CAPT_LIGNS];
static periodicTask * lineSensor[NB_CAPT_LIGNS];




/*

 ^ y    /
 |     /            +----------
 |    /--           |
 |   /| \  alpha du get_alpha
 |  /    \          |
 | /      |         |     
 |/       |  x  +---+
 +----------->  |          
                |    
                |  
                +---+
                    |	   
                    |
                    |
                    |
          (0,0) --> +----------
    (origine du repere)

les mesures sont en mm et en rad



                  X
         ^       /     
         |      / -- 
         |     /  |\       
   /-----------\    \  cette fleche (si si c'est une fleche)
  /     ===  /  \    \  donne le sens d'orientation de l'angle alpha  donner pour le capteur
 /       |  /    \    |    
 |       | /     |    |  
 |       |/      |    |  
 |       +-------|-----> 
 |               |
 |               |
 \               /
  \     ===     /
   \-----------/
  

*/


#endif




