

#ifndef __GONIO_KALMAN__
#define  __GONIO_KALMAN__


#include "projet_kalman.h"
#include <math.h>
#include <stdio.h>

Mtx_Matrix* jacobGonio;  //(vecteurligne 3 colones)
//Mtx_Matrix* mesureGonio; //(1x1)
//Mtx_Matrix* erreurGonio;




//------------------------------------------------------------------------
// methode calculJacobGonio
//------------------------------------------------------------------------

void calculJacobGonio(double x,double y, double mesure){ //x et y representent la position de l'emetteur

  double xr,yr,theta,L,b,dmdx,dmdy,dmda;

  jacobGonio=Mtx_GetNewMatrix (1, 3);
 
  //la jacobienne c'est un truc de la forme : 

  //transposee de : 

  // [-1/L sin(b) ] 
  // [1/L cos(b)  ]
  // [  -1        ]

  // avec L=sqrt((x-xr)+(y-yr))
  // et b=theta+m

 xr=get( position,0,0);
 yr=get( position,1,0);
 theta=get( position,2,0);

 L=L=sqrt((x-xr)*(x-xr)+(y-yr)*(y-yr));
 b=theta+mesure;

 if(L!=0){
   dmdx=sin(b)/L;
   dmdy=-cos(b)/L;
   dmda=-1;
   }


 else {
   printf("probleme calcul jacob gonio\n");
   return;
 }
 set(jacobGonio,0,0,dmdx);  //dm/dx
 set(jacobGonio,0,1,dmdy);
 set(jacobGonio,0,2,dmda);
 //Mtx_MatrixPrint(jacobGonio);
 //printf("fin de calcul jacob gonio\n");
  return ;
}
//------------------------------------------------------
//   methode fusion mesure Gonio
//------------------------------------------------------


void fusionMesureGonio(double mes, double x,double y,double erreur){

 Mtx_Matrix * erreur_mesure, * mesure,*jacob_mesure;

 double xr,yr,alphar,xp,yp,m,dm;

 //------calcul de la mesure attendue---------

 xr=get( position,0,0);
 yr=get( position,1,0);
 alphar=get( position,2,0);


  xp=-xr+x;
  yp=-yr+y;

  printf("xp %f, yp %f\n",xp,yp);
  m=atan(yp/xp);

 if(xp<=0 && yp>0) m=m+3.14;
 if(xp<=0 && yp<0) m=m-3.14;
 
 m=m-alphar;

 //-------------calcul du dm----------------------------
  

 dm=mes-m;

 if(dm > 3.14) dm=dm-2*3.14;
 if(dm < -3.14) dm=dm+2*3.14;

 printf("mesure attendue : %f delta mesure : %f\n",m,dm);


 //--------------application du kalman------------------------



 calculJacobGonio(x,y, mes);
 

 jacob_mesure=jacobGonio; //(vecteurligne 3 colones)

 erreur_mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(erreur_mesure,0,0,erreur*erreur);
 mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(mesure,0,0,dm);

 //printf("calcul gain\n");
 calculGain(jacob_mesure, erreur_mesure, mesure);
 //printf("update state\n");
 generalised_updateState(mesure);
 //printf("update erreur\n");
 update_erreur(jacob_mesure);

Mtx_DeleteMatrix(erreur_mesure);
Mtx_DeleteMatrix(mesure);
Mtx_DeleteMatrix(jacob_mesure);

//----------------fin du filtre de kalman-----------


}

//---------------------------------------------------------------
//
//----------------------------------------------------------------



#endif //gonio






















