


#ifndef __GONIO_KALMAN__
#define  __GONIO_KALMAN__

#include "gonio2.h"
#include "projet_kalman.h"
#include <math.h>
#include <stdio.h>

Mtx_Matrix* jacobGonio;  //(vecteurligne 3 colones)


double R2=50.;
double alpha2=1.1;




/* The options were    : operatorarrow */
double dmdx(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
  double t4;
  double t9;
  double t11;
  double t1;
  double t8;

  t1 = theta+alpha;
  t4 = yb-yr-R*sin(t1);
  t8 = pow(xb-xr-R*cos(t1),2);
  t9 = 1/t8;
  t11 = t4*t4;
  return(t4*t9/(1+t11*t9));
}


/* The options were    : operatorarrow */
double dmda(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
double t3;
  double t1;
  double t4;
  double t8;
  double t11;
  double t10;
  double t15;
  double t9;

  t1 = theta+alpha;
  t3 = R*cos(t1);
  t4 = xb-xr-t3;
  t8 = R*sin(t1);
  t9 = yb-yr-t8;
  t10 = t4*t4;
  t11 = 1/t10;
  t15 = t9*t9;
  return((-t3/t4-t9*t11*t8)/(1+t15*t11)-1);

}

/* The options were    : operatorarrow */
double dmdy(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
  double t1;
  double t9;
  double t10;
  double t4;

  t1 = theta+alpha;
  t4 = xb-xr-R*cos(t1);
  t9 = pow(yb-yr-R*sin(t1),2);
  t10 = t4*t4;
  return(-1/t4/(1+t9/t10));
}



/* The options were    : operatorarrow */
double z(xb,yb)
double xb;
double yb;
{
  double t1;
  double m;

  double xr,yr,thetar,xp,yp;

 xr=get( position,0,0);
 yr=get( position,1,0);
 thetar=get( position,2,0);


  t1 = thetar+alpha2;
  

  xp=-xr+xb-R2*cos(t1);
  yp=-yr+yb-R2*sin(t1);


  //printf("xp %f, yp %f\n",xp,yp);
  m=atan(yp/xp);

 if(xp<=0 && yp>0) m=m+3.14;
 if(xp<=0 && yp<0) m=m-3.14;
 
 m=m-thetar;

 return m;
}

void calculJacobGonio_decentre(double x,double y){

  double xr,yr,theta,dmdxt,dmdyt,dmdat;

  jacobGonio=Mtx_GetNewMatrix (1, 3);
 

 xr=get( position,0,0);
 yr=get( position,1,0);
 theta=get( position,2,0);

 dmdxt= dmdx(xr,yr,theta,alpha2,x,y,R2);
 dmdyt= dmdy(xr,yr,theta,alpha2,x,y,R2);
 dmdat= dmda(xr,yr,theta,alpha2,x,y,R2);

 set(jacobGonio,0,0,dmdxt);  //dm/dx
 set(jacobGonio,0,1,dmdyt);
 set(jacobGonio,0,2,dmdat);


}


void calculJacobGonio(double x,double y, double mesure){ //x et y representent la position de l'emetteur

  double xr,yr,theta,L,b,dmdx,dmdy,dmda;

  jacobGonio=Mtx_GetNewMatrix (1, 3);
 
  //la jacobienne c'est un truc de la forme : 

  //transposee de : 

  // [-1/L sin(b) ] 
  // [1/L cos(b)  ]
  // [  -1        ]

  // avec L=sqrt((x-xr)+(y-yr))
  // et b=theta+m

 xr=get( position,0,0);
 yr=get( position,1,0);
 theta=get( position,2,0);

 L=L=sqrt((x-xr)*(x-xr)+(y-yr)*(y-yr));
 b=theta+mesure;

 if(L!=0){
   dmdx=sin(b)/L;
   dmdy=-cos(b)/L;
   dmda=-1;
   }


 else {
   printf("probleme calcul jacob gonio\n");
   return;
 }
 set(jacobGonio,0,0,dmdx);  //dm/dx
 set(jacobGonio,0,1,dmdy);
 set(jacobGonio,0,2,dmda);
 //Mtx_MatrixPrint(jacobGonio);
 //printf("fin de calcul jacob gonio\n");
  return ;
}


//------------------------------------------------------
//   methode fusion mesure Gonio
//------------------------------------------------------


void fusionMesureGonio_2(double mes, double x,double y,double erreur){

 Mtx_Matrix * erreur_mesure, * mesure,*jacob_mesure;

 double m,dm,m2;
 double xr,yr,alphar,xp,yp;

 //-------------------------------------------
 //premiere version du calcul de la mesure
 //-----------------------------------------

 xr=get( position,0,0);
 yr=get( position,1,0);
 alphar=get( position,2,0);


  xp=-xr+x;
  yp=-yr+y;

  //printf("xp %f, yp %f\n",xp,yp);
  m2=atan(yp/xp);

 if(xp<=0 && yp>0) m2=m2+3.14;
 if(xp<=0 && yp<0) m2=m2-3.14;
 
 m2=m2-alphar;




 //------calcul de la mesure attendue---------
 m=z(x,y);
 printf("estimation mesure nouvelle %f\n",m);
 printf("estimation mesure ancienne %f\n",m2);
 //-------------calcul du dm----------------------------
  

 dm=mes-m;

 if(dm>3.14) dm=dm-(2*3.14);
 if(dm<-3.14) dm=dm+(2*3.14);
 if(dm>3.14) dm=dm-(2*3.14);
 if(dm<-3.14) dm=dm+(2*3.14);



 printf("mesure attendue : %f delta mesure : %f\n",m,dm);


 //--------------application du kalman------------------------


 calculJacobGonio(x,y,mes);
 printf("ancienne jacobienne : ");
 Mtx_MatrixPrint(jacobGonio);
 Mtx_DeleteMatrix(jacobGonio);
 calculJacobGonio_decentre(x,y);
 printf("nouvelle jacobienne : ");
 Mtx_MatrixPrint(jacobGonio);


 jacob_mesure=jacobGonio; //(vecteurligne 3 colones)

 erreur_mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(erreur_mesure,0,0,erreur*erreur);
 mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(mesure,0,0,dm);

 //printf("calcul gain\n");
 calculGain(jacob_mesure, erreur_mesure, mesure);
 //printf("update state\n");
 generalised_updateState(mesure);
 //printf("update erreur\n");
 update_erreur(jacob_mesure);

Mtx_DeleteMatrix(erreur_mesure);
Mtx_DeleteMatrix(mesure);
Mtx_DeleteMatrix(jacob_mesure);

//----------------fin du filtre de kalman-----------


}




#endif //gonio

