

#ifndef __interprete_k__
#define __interprete_k__


#include "projet_kalman.h"
#include "lignes.h"
#include "interprete_kalman.h"
#include <stdio.h>
#include "geometrieKalman.h"



int etat=0;
int count=0;
int initialise=0;

static double odo1=0;  //en mm
static double odo2=0;
static double diametre=340;

 double getAngleOdo(){
   return (odo2-odo1)/diametre;
};
double getDistOdo(){
  return (odo1+odo2)/2;
};


//etat 
/*
0 attente de commande
1 commande init  (inter_x,inter_y,inter_alpha, inter_erreur_xy, inter_erreur_alpha)
2 recalage odometre (dx,dy)
3 recalage ligne (num du capteur)
4 setPosition (inter_x,inter_y,inter_alpha, inter_erreur_xy, inter_erreur_alpha)

*/


void etat0(double d){
  // printf("commande : %f\n",d);
  etat=d;
  count=0;
  return;

}

double inter_x,inter_y,inter_alpha, inter_erreur_xy, inter_erreur_alpha;

void etat1(double d){ //initialisation du kalman
  count++;
  //printf("kalman initialise...\n");
  if(count==1)  inter_x=d;
  if(count==2)  inter_y=d;
  if(count==3)  inter_alpha=d;
  if(count==4) inter_erreur_xy=d;
  if(count==5) {
    initialise=1;
    inter_erreur_alpha=d;
    //printf("kalman initialise...\n");
    initKalman(inter_x, inter_y, inter_alpha, inter_erreur_xy, inter_erreur_alpha);
  
    buildTableauDesLignes();

    //printf("kalman initialise...\n");

    etat=0;
  }
  return;


};





double d1,d2;

void etat2(double d){
  count++;
  if(count==1) d1=d;
  if(count==2) {
    d2=d;
    odo1+=d1;
    odo2+=d2;
    if(initialise==0 || (odo1<1. && odo2<1. && odo1>-1. && odo2>-1.)) {
      etat=0;
      return;
    }   
    //printf("d1=%f d2=%f\n",odo1,odo2);
   
    positionUpdate();

#ifdef DEBUG
    printf("odo1 =%f odo2=%f",odo1,odo2);
    printf("x= %f y= %f, alpha= %f\n",getx(),gety(),get_alpha());
#endif

    odo1=0;
    odo2=0;
    etat=0;

  }
  return;

}


void etat3(double d){
  struct capteur c;

  if(initialise==0) {
    etat=0;
    return;

  }
  /*
  if(d==1) {
    c.R=130;
    c.alpha=-0.2;
    printf("capteur droit\n");
  }

  if(d==2){
    c.R=130;
    c.alpha=-0.2;
    printf("capteur gauche\n");

  }
  */
  c.R=Rayon[(int)d];
  c.alpha=Angle[(int)d];
 
  fusionMesureCapteurLigne(&c,20.);
  etat=0;

}



void etat4(double d){ //initialisation du kalman
  count++;
  //printf("kalman initialise...\n");
  if(count==1)  inter_x=d;
  if(count==2)  inter_y=d;
  if(count==3)  inter_alpha=d;
  if(count==4) inter_erreur_xy=d;
  if(count==5) {

    inter_erreur_alpha=d;
    //printf("kalman initialise...\n");
    setPositionKalman(inter_x, inter_y, inter_alpha, inter_erreur_xy, inter_erreur_alpha);
    //printf("kalman initialise...\n");

    etat=0;
  }
  return;


};


void interprete_kalman(double d){

  //printf("recu : %f\n",d);
  switch (etat){
  case 0:
    etat0(d);
    break;
  case 1:
    etat1(d);
    break;
  case 2:
    etat2(d);
    break;
  case 3:
    etat3(d);
  case 4:
    etat4(d);
    break;

   
  } 


}

#endif







