


#ifndef __GONIO_KALMAN__
#define  __GONIO_KALMAN__


#include "projet_kalman.h"
#include <math.h>
#include <stdio.h>

Mtx_Matrix* jacobGonio;  //(vecteurligne 3 colones)


double R=10.;
double alpha=1.;





/* The options were    : operatorarrow */
double dmdx(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
  double t4;
  double t9;
  double t11;
  double t1;
  double t8;

  t1 = theta+alpha;
  t4 = yb-yr-R*sin(t1);
  t8 = pow(xb-xr-R*cos(t1),2);
  t9 = 1/t8;
  t11 = t4*t4;
  return(t4*t9/(1+t11*t9));
}


/* The options were    : operatorarrow */
double dmda(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
  double t1;
  double t3;
  double t4;
  double t9;
  double t8;
  double t10;
  double t11;
  double t15;

  t1 = theta+alpha;
  t3 = R*cos(t1);
  t4 = xb-xr-t3;
  t8 = R*sin(t1);
  t9 = yb-yr-t8;
  t10 = t4*t4;
  t11 = 1/t10;
  t15 = t9*t9;
  return((-t3/t4-t9*t11*t8)/(1+t15*t11));
}

/* The options were    : operatorarrow */
double dmdy(xr,yr,theta,alpha,xb,yb,R)
double xr;
double yr;
double theta;
double alpha;
double xb;
double yb;
double R;
{
  double t1;
  double t9;
  double t10;
  double t4;

  t1 = theta+alpha;
  t4 = xb-xr-R*cos(t1);
  t9 = pow(yb-yr-R*sin(t1),2);
  t10 = t4*t4;
  return(-1/t4/(1+t9/t10));
}



/* The options were    : operatorarrow */
double z(alpha,R,xb,yb)
double alpha;
double xb;
double yb;
double R;
{
  double t1;
  double m;

  t1 = theta+alphar;

 xr=get( position,0,0);
 yr=get( position,1,0);
 alphar=get( position,2,0);


  xp=-xr+xb-R*cos(t1);
  yp=-yr+yb-R*sin(t1);


  //printf("xp %f, yp %f\n",xp,yp);
  m=atan(yp/xp);

 if(xp<=0 && yp>0) m=m+3.14;
 if(xp<=0 && yp<0) m=m-3.14;
 
 m=m-alphar;

 return m;
}

calculJacobGonio_decentre(double x,double y){


  jacobGonio=Mtx_GetNewMatrix (1, 3);
 

 xr=get( position,0,0);
 yr=get( position,1,0);
 theta=get( position,2,0);

 dmdxt= dmdx(xr,yr,theta,alpha,x,y,R);
 dmdyt= dmdy(xr,yr,theta,alpha,x,y,R);
 dmdat= dmda(xr,yr,theta,alpha,x,y,R);

 set(jacobGonio,0,0,dmdxt);  //dm/dx
 set(jacobGonio,0,1,dmdyt);
 set(jacobGonio,0,2,dmdat);


}


//------------------------------------------------------
//   methode fusion mesure Gonio
//------------------------------------------------------


void fusionMesureGonio_2(double mes, double x,double y,double erreur){

 Mtx_Matrix * erreur_mesure, * mesure,*jacob_mesure;

 double xr,yr,alphar,xp,yp,m,dm;

 //------calcul de la mesure attendue---------
 m=z(alpha,R,x,y);
 //-------------calcul du dm----------------------------
  

 dm=mes-m;

 if(dm > 3.14) dm=dm-2*3.14;
 if(dm < -3.14) dm=dm+2*3.14;

 printf("mesure attendue : %f delta mesure : %f\n",m,dm);


 //--------------application du kalman------------------------



 calculJacobGonio_decentre(x,y, mes);
 

 jacob_mesure=jacobGonio; //(vecteurligne 3 colones)

 erreur_mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(erreur_mesure,0,0,erreur*erreur);
 mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(mesure,0,0,dm);

 //printf("calcul gain\n");
 calculGain(jacob_mesure, erreur_mesure, mesure);
 //printf("update state\n");
 generalised_updateState(mesure);
 //printf("update erreur\n");
 update_erreur(jacob_mesure);

Mtx_DeleteMatrix(erreur_mesure);
Mtx_DeleteMatrix(mesure);
Mtx_DeleteMatrix(jacob_mesure);

//----------------fin du filtre de kalman-----------


}




#endif //gonio

