#include <pthread.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include "kalman_fifo.h"

struct kalman_fifo * createFifo(int size){

  struct kalman_fifo * kf=(struct kalman_fifo *)malloc(sizeof(struct kalman_fifo));


  kf->debut=(char *)malloc(size*sizeof(char));
  kf->begin=0;
  kf->end=0;
  kf->size=size;
  kf->data=0;

  pthread_mutex_init(&(kf->mutex),NULL);
  pthread_cond_init(&(kf->condition),NULL);


  return kf;


}

void destroyfifo(struct kalman_fifo * fifo){
  pthread_cond_destroy(&(fifo->condition));
  pthread_mutex_destroy(&(fifo->mutex));
  free(fifo->debut);
  free(fifo);
}

int putfifo(struct kalman_fifo * fifo,void * pointeur, int size){
  int continuer;
  int i;
  char * ptemp=(char *) pointeur;
  i=0;

pthread_mutex_lock(&(fifo->mutex));
  

 continuer=0;
 while(continuer==0){

   
    

    if(fifo->size-fifo->data<=size) {
      printf("blocage de la fifo\n");
      pthread_cond_wait(&(fifo->condition),&(fifo->mutex));
      continuer=0;
    }
    else{
      continuer=1;
    }
  }




 while(size>i){
   fifo->debut[fifo->end]=ptemp[i];
   i++;


   fifo->end++;
   if(fifo->end>=fifo->size) fifo->end=0;
   
 }
 //printf("fifo ->end %i fifo->begin %i\n",(int)fifo->begin,(int)fifo->end);

 fifo->data+=size;
 
 pthread_mutex_unlock(&(fifo->mutex));
 pthread_cond_broadcast(&(fifo->condition));

 return 1;
}


void * readfifo(struct kalman_fifo * fifo,void * pointeur, int size){

  int continuer=0;
  int i=0;
 char * ptemp=(char *)pointeur;
  
pthread_mutex_lock(&(fifo->mutex));




  while(continuer==0){

   
    

    if(fifo->data<size) {
      pthread_cond_wait(&(fifo->condition),&(fifo->mutex));
      continuer=0;
    }
    else{
      continuer=1;
    }
  }

  i=0;

 while(size>i){
   ptemp[i]=fifo->debut[fifo->begin];
   i++;
   fifo->begin++;
   if(fifo->begin>=fifo->size) fifo->begin=0;
   
 }
 fifo->data-=size;

 pthread_mutex_unlock(&(fifo->mutex));
 pthread_cond_broadcast(&(fifo->condition));

 return pointeur;
}


/*
main(){
  int i;
  double d;
struct kalman_fifo * kf;

 printf("coucou\n");
 kf=createFifo(100*sizeof(double));
 printf("coucou\n");
 for(d=0; d<100 ; d++){
   putfifo(kf,(void *)&d, sizeof(double));
 }
 printf("coucou\n");
 for(i=0 ; i<100 ; i++){

   readfifo(kf,(void *)&d, sizeof(double));
   printf(" %f",d);

 }

 for(d=0; d<100 ; d++){
   putfifo(kf,(void *)&d, sizeof(double));
 }

 for(i=0 ; i<100 ; i++){

   readfifo(kf,(void *)&d, sizeof(double));
   printf(" %f",d);

 }

 printf("c'est fini !\n");


  for(i=0 ; i<10 ; i++){

   readfifo(kf,(void *)&d, sizeof(char));
   printf(" %f",d);

 }





}

*/
