
#include <math.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include "projet_kalman.h"



float odoNoiseX=0.005;
float odoNoiseY=0.005;
float odoNoiseAlpha=0.00005;

int kalman_initialise=0;


//---------------------------------------------------------------------
// methode getx()
//---------------------------------------------------------------------

double getx(){

  if(kalman_initialise==1) {
    return get(position,0,0);
  }
  return 0;

}

double gety(){
  
  if(kalman_initialise==1){
    return get(position,1,0);
   }
  return 0;

}



double get_alpha(){

  if(kalman_initialise==1) {
    return get(position,2,0);
   }
  return 0;

}



void print_erreur(){
  printf("erreur de position : \n");
  Mtx_MatrixPrint  ( erreurPosition);

}


//----------------------------------------------------------------------
// methode updatePosition
//----------------------------------------------------------------------



Mtx_Matrix* getErreurOdo(){

  return erreurOdo;

}


Mtx_Matrix *  getUpdatePosMatrix(double dl){ //dl est la longueur du pas en cours

  double x,y,a;
 

 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);


 set(updatePosMatrix,0,0,1);
 set(updatePosMatrix,1,1,1);
 set(updatePosMatrix,2,2,1);

 set(updatePosMatrix,0,2,-sin(a)*dl);

 set(updatePosMatrix,1,2,cos(a)*dl);

  return updatePosMatrix;
}


void positionUpdate(){
  double x,y,a,l,b;
  Mtx_Matrix * temp1,*temp2,*temp3,*upm;

 x=get( position,0,0);
 y=get( position,1,0);
 a=get( position,2,0);

 l= getDistOdo();
 b=getAngleOdo();
 
 //update de la premiere partie de l'erreur

 upm=getUpdatePosMatrix(l);
 temp1=Mtx_Transpose(upm);
 temp2=Mtx_Product(upm,erreurPosition);
 temp3=Mtx_Product(temp2,temp1);
 
 Mtx_DeleteMatrix(temp1);
 Mtx_DeleteMatrix(temp2);

 Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=temp3;
 
 //l'angle est donn modulo Pi

 x=x+l*cos(a);
 y=y+l*sin(a);
 a=a+b;

 //printf("a:=%f\n",a);

 if(a>3.1415) {
   a=a-(2*3.1415);
   //printf("a>pi\n");
 }

 if(a<-3.1415) a=a+(2*3.1415);

 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,a);

 //update de la seconde partie de l'erreur
 temp1=Mtx_Sum(erreurPosition,getErreurOdo());
 Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=temp1;
 Mtx_MatrixPrint(erreurPosition);

 return;
}

//-----------------------------------------------------------------------
//  calcul du gain de kalman
//-----------------------------------------------------------------------

void calculGain(Mtx_Matrix * jacob_mesure, Mtx_Matrix * erreur_mesure, Mtx_Matrix * mesure){

  Mtx_Matrix * temp1,*temp2,*temp3,*temp4,*temp5,*trjg;
  //printf("debut du calcul de k\n");

 
  //K=P (Ht)(H P Ht +R)^-1

  trjg=Mtx_Transpose(jacob_mesure);
  temp1=Mtx_Product(erreurPosition,trjg);
  temp2=Mtx_Product(jacob_mesure,erreurPosition);
  temp3=Mtx_Product(temp2,trjg);
  temp4=Mtx_Sum(temp3,erreur_mesure); 
 
  //attention aux cas ou la matrice n'est pas inversible qui ne sont pas traits
  //printf("attention inversion\n");
  //Mtx_MatrixPrint(temp4);
  temp5=Mtx_Inverse(temp4);
  //printf("inversion reussie\n");

  
  Mtx_DeleteMatrix(k);
  k=Mtx_Product(temp1,temp5);

 Mtx_DeleteMatrix(temp1);
 Mtx_DeleteMatrix(temp2);
 Mtx_DeleteMatrix(temp3);
 Mtx_DeleteMatrix(temp4);
 Mtx_DeleteMatrix(temp5);
 Mtx_DeleteMatrix(trjg); 

 //printf("k:\n");
 //Mtx_MatrixPrint(k);
  return;

}

//------------------------------------------------------------------------
//   updateState 
//------------------------------------------------------------------------

void updateState(Mtx_Matrix * jacob_mesure, Mtx_Matrix * mesure){

  Mtx_Matrix * temp1,*temp2,*temp3,*temp4,*tempPosition;
 double a;

 //x=x+k(z-Hx)

 temp1=Mtx_Product(jacob_mesure,position);
 temp2=mesure;
 temp3=Mtx_Substract(temp2,temp1);

 a=get(temp3,2,0);              //tres important !
 if(a>3.1415) a=a-2*(3.1415);  //les mesures d'angle se font modulo pi
 if(a<-3.1415) a=a+2*3.1415;
 set(temp3,2,0,a);


 temp4=Mtx_Product(k,temp3);
 tempPosition=Mtx_Sum(position,temp4);
 Mtx_DeleteMatrix(position);
 position=tempPosition;

 Mtx_DeleteMatrix(temp1);
 Mtx_DeleteMatrix(temp3);
 Mtx_DeleteMatrix(temp4);


}
void generalised_updateState(Mtx_Matrix * deltamesure){

 Mtx_Matrix *temp3,*temp4,*tempPosition;
 double a;

  temp3=deltamesure;

 a=get(temp3,0,0);              //tres important !
 if(a>3.1415) a=a-2*(3.1415);  //les mesures d'angle se font modulo 2*pi
 if(a<-3.1415) a=a+2*3.1415;
 set(temp3,0,0,a);
 Mtx_MatrixPrint(k);

 temp4=Mtx_Product(k,temp3);
 tempPosition=Mtx_Sum(position,temp4);
 Mtx_DeleteMatrix(position);
 position=tempPosition;


 Mtx_DeleteMatrix(temp4);


}
//------------------------------------------------------------------------
// update errorCov
//------------------------------------------------------------------------


void update_erreur(Mtx_Matrix * jacob_mesure){

Mtx_Matrix *temp5, *temp6,*tempErreurPosition;

 //--------------update de l'erreur--------
 //P=(I-KH)P 

 temp5=Mtx_Product(k,jacob_mesure);
 temp6=Mtx_SubToIdent(temp5);
 tempErreurPosition=Mtx_Product(temp6,erreurPosition);
 Mtx_DeleteMatrix(erreurPosition);
 erreurPosition=tempErreurPosition;
 Mtx_DeleteMatrix(temp5);
 Mtx_DeleteMatrix(temp6);


 return;

}



//---------------------------------------------------
//  fusionMesurePosition
//---------------------------------------------------

void fusionMesureAngle(double angle, double erreur){

 Mtx_Matrix * erreur_mesure, * mesure,*jacob_mesure;
  
 jacob_mesure=Mtx_GetNewMatrix(1,3); //(vecteurligne 3 colones)
 set(jacob_mesure,0,2,1);
 erreur_mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(erreur_mesure,0,0,erreur*erreur);
 mesure=Mtx_GetNewMatrix(1,1); //(vecteurligne 1 colones)
 set(mesure,0,0,angle);

 

 calculGain(jacob_mesure, erreur_mesure, mesure);
 updateState(jacob_mesure,mesure);
 update_erreur(jacob_mesure);

Mtx_DeleteMatrix(erreur_mesure);
Mtx_DeleteMatrix(mesure);
Mtx_DeleteMatrix(jacob_mesure);

}


void fusionMesurePosition(double x,double y,double erreur){


 Mtx_Matrix * erreur_mesure, * mesure,*jacob_mesure;

 //on definie les matrices de mesure

  
 jacob_mesure=Mtx_GetNewMatrix(2,3); //(vecteur 2 lignes 3 colones)
 set(jacob_mesure,0,0,1);
 set(jacob_mesure,1,1,1);
 erreur_mesure=Mtx_GetNewMatrix(2,2); //(vecteur 2 lignes  2 colone)
 set(erreur_mesure,0,0,erreur*erreur);
 set(erreur_mesure,1,1,erreur*erreur);
 mesure=Mtx_GetNewMatrix(2,1); //(vecteur 2 lignes 1 colones)
 set(mesure,0,0,x);
 set(mesure,1,0,y);

 //on applique l'ago de kalman avec ces valeurs

 //printf("calcul gain\n");
 calculGain(jacob_mesure, erreur_mesure, mesure);
 //printf("update state\n");
 updateState(jacob_mesure,mesure);
 //printf("update erreur\n"); 
 update_erreur(jacob_mesure);

 //on efface les matrices temporaires

Mtx_DeleteMatrix(erreur_mesure);
Mtx_DeleteMatrix(mesure); 
Mtx_DeleteMatrix(jacob_mesure);


}


//---------------------------------------------------
//  methode initKalman
//---------------------------------------------------

void initKalman(double x,double y,double alpha,double erreur_xy,double erreur_alpha){

  //printf("intialisation du filtre de kalman....\n");
 Mtx_ManagerInit();  

position=Mtx_GetNewMatrix(3,1); //(vecteur colonne 3 lignes)
erreurPosition=Mtx_GetNewMatrix(3,3); //(3x3)
erreurOdo=Mtx_GetNewMatrix(3,3); //(3x3)

 set(erreurPosition,0,0,erreur_xy*erreur_xy);
 set(erreurPosition,1,1,erreur_xy*erreur_xy);
 set(erreurPosition,2,2,erreur_alpha*erreur_alpha);


 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,alpha);

 set(erreurOdo,0,0,odoNoiseX);
 set(erreurOdo,1,1,odoNoiseY);
 set(erreurOdo,2,2,odoNoiseAlpha);



 updatePosMatrix=Mtx_GetNewMatrix(3,3);

 k=Mtx_GetNewMatrix(3,3); //gain de kalman
  
 kalman_initialise=1;
 //printf("....fini\n");
 return;


}

//---------------------------------------------------
//  setPosition
//---------------------------------------------------

void setPositionKalman(double x,double y,double alpha,double erreur_xy,double erreur_alpha){


 set(position,0,0,x);
 set(position,1,0,y);
 set(position,2,0,alpha);
Mtx_DeleteMatrix(erreurPosition);
erreurPosition=Mtx_GetNewMatrix(3,3);


 set(erreurPosition,0,0,erreur_xy*erreur_xy);
 set(erreurPosition,1,1,erreur_xy*erreur_xy);
 set(erreurPosition,2,2,erreur_alpha*erreur_alpha);



};


