
#ifndef __PROJET_KALMAN__
#define  __PROJET_KALMAN__

#include "matrix.h"


//-----------------------------------------------------------------------
//    les appels "systems"
//-----------------------------------------------------------------------


extern double getAngleOdo();
extern double getDistOdo();


float odoNoiseX;
float odoNoiseY;
float odoNoiseAlpha;


//-----------------------------------------------------------------------
//  variables gloabales
//-----------------------------------------------------------------------

//on utilise une architecture simplifie
//toutes les variables importantes sont globales


Mtx_Matrix* position; //(vecteur colonne 3 lignes)
Mtx_Matrix* erreurPosition; //(3x3)
Mtx_Matrix* updatePosMatrix;   //Aij  
Mtx_Matrix* mesureGonio; //(1x1)
Mtx_Matrix* erreurGonio;

Mtx_Matrix* erreurOdo;

Mtx_Matrix* k; //gain de kalman

int kalman_initialise;

//------------------------------------------------------------------
// les methodes
//------------------------------------------------------------------

double getx();
double gety();
double get_alpha();

void print_erreur();

Mtx_Matrix* getErreurOdo(); //retourne la matrice de bruit de l'odometre

Mtx_Matrix *  getUpdatePosMatrix(double dl); //retourne la jacobienne de la mesure par odometre 
                                            //dl est la longueur du pas en cours


void positionUpdate(); //update la position et l'erreur sur la position
void calculGain(Mtx_Matrix * jacob_mesure, Mtx_Matrix * erreur_mesure, Mtx_Matrix * mesure);  //calcul le gain de kalman
void updateState(Mtx_Matrix * jacob_mesure, Mtx_Matrix * mesure) ;//update la position apres une mesure et le calcul du gain de kalman
void update_erreur(Mtx_Matrix * jacob_mesure);//update l'erreur de position apres une mesure et le calcul du gain de kalman


void fusionMesureAngle(double angle, double erreur); //fusione une mesure de l'angle avec l'estimation courante
void fusionMesurePosition(double x,double y,double erreur); //fusionne une mesiure de position avec l'estimateur courant

void initKalman(double x,double y,double alpha,double erreur_xy,double erreur_alpha); //lance la filtre
void setPositionKalman(double x,double y,double alpha,double erreur_xy,double erreur_alpha);


void generalised_updateState(Mtx_Matrix * deltamesure);

#endif//  __PROJET_KALMAN__
