#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <errno.h>
#include <stdio.h>

#define BAUDRATE B9600
#define MODEMDEVICE "/dev/ttyS1"
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1

volatile int STOP=FALSE;

int fd;
struct termios oldtio;

void initSerialPort()
{
  int c, res;
  struct termios newtio;
  
  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY );
  if (fd <0) {perror(MODEMDEVICE); exit(-1); }
  
  tcgetattr(fd,&oldtio); /* save current port settings */
  
  bzero(&newtio, sizeof(newtio));
  //        newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;
  newtio.c_cflag = BAUDRATE | CS8 | CLOCAL | CREAD;
  newtio.c_iflag = INPCK  | PARMRK | ISTRIP;
//  newtio.c_iflag = IGNPAR;
  newtio.c_oflag = 0;
  
  /* set input mode (non-canonical, no echo,...) */
  newtio.c_lflag = 0;
  
  newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
  newtio.c_cc[VMIN]     = 1;   /* blocking read until 5 chars received */
  
  tcflush(fd, TCIFLUSH);
  tcsetattr(fd,TCSANOW,&newtio);
}

void closeSerialPort()
{
  tcsetattr(fd,TCSANOW,&oldtio);
}

#define CMD_A 161


void serial_interpret()
{
  unsigned char buf[255];
  int res;

  buf[0]='a';

  while (STOP==FALSE) {       /* loop for input */
    printf ("Write\n");
    write(fd,buf,1);
    printf ("Read\n");
    res = read(fd,buf,1);
    if (res == -1) printf ("%s\n", strerror(errno));
    printf(":%d:%c\n", buf[0],buf[0]);
    
    switch (buf[0])
      {
      case CMD_A :
	printf("Electro1\n");
	break;
      }
    
    if (buf[0]=='z') STOP=TRUE;
  }

}

main()
{
  initSerialPort();

  serial_interpret();

  closeSerialPort();

}
