#ifndef COLLISION_SOLUTION_H
#define COLLISION_SOLUTION_H

/*   POSITION des capteurs
         1
         _
       7| |8
        | |
        | |
  3_____| |______4
 |______   _______|
  5     | |      6
        | |
        | |
       9|_|10
         2


*/

#define COLLI_CAPT_FRONT 	1
#define COLLI_CAPT_FRONT_L 7
#define COLLI_CAPT_FRONT_R 8
#define COLLI_CAPT_REAR 	2
#define COLLI_CAPT_REAR_L 	9
#define COLLI_CAPT_REAR_R 	10
#define COLLI_CAPT_RIGHT_F 4
#define COLLI_CAPT_RIGHT_R 6
#define COLLI_CAPT_LEFT_F 	3
#define COLLI_CAPT_LEFT_R 	5

#define OK 	0
#define ERROR -1
#define NO_COLLISION_ADDED_BEFORE_GET_SOLUTION 2  /* get solution call before CollisionDetected */
#define NO_SOLUTION_AVAILABLE 3/* no solution computed or no solution found */

void collision_initModule();
void CollisionDetected(int captor, double Robotx, double Roboty, double Robottheta);
int  CollisionGetSolution(double *speedR, double *speedL, double *distToRun);
void CollisionSetParameters(double speed, double reducedFactor, double distance);
#endif