#ifndef __EVENTS_H__
#define __EVENTS_H__

#include <pthread.h>

#define EVENT_JOIN_NO  0
#define EVENT_JOIN_OR  1
#define EVENT_JOIN_AND 2


typedef struct Event
{
  pthread_cond_t cond;
  pthread_mutex_t condMutex;
  struct Event* event1;
  struct Event* event2;
  unsigned char joinType;
  char eventName[50];
  struct Event* signalingEvent;
  int isLocked;
} Event;

extern void createEvent(Event* event, char* eventName);
extern void lockEvent(Event* event);
extern void broadcastEvent(Event* event);

extern void waitEvent(Event* event);

extern void orEvents(Event* event1, Event* event2, Event* eventResult);

extern void andEvents(Event* event1, Event* event2, Event* eventResult);

typedef void (*EventCallback)(Event* event);

extern void createCallback(Event* event,  EventCallback callback);

#endif // __EVENTS_H__
