#ifndef __I2C_SERVOS__
#define __I2C_SERVOS__

#include "i2cManager.h"

#define ARM_SERVO 3
#define LEFT_SERVO 1
#define RIGHT_SERVO 0

#define MIN_ARM_SERVO 3
#define MAX_ARM_SERVO 29

#define MIN_LEFT_SERVO 19
#define MAX_LEFT_SERVO 35
#define IN_LEFT_SERVO 35
#define OUT_LEFT_SERVO 19

#define MIN_RIGHT_SERVO 10
#define MAX_RIGHT_SERVO 25
#define IN_RIGHT_SERVO 10
#define OUT_RIGHT_SERVO 25

#define DEBUG_MODULE_NAME SERVOS
#include "debug.h"

static void setServoPos(unsigned char servoID, unsigned char servoPos)
{
  debug_printf(DEBUG_MODULE_NAME,"Setting servo n %d to pos. %d\n",servoID, servoPos);
  if (servoPos >= (1<<6)) servoPos=(1<<6)-1;
  i2cSend (I2C_SERVOS_SLAVE,  (servoID << 6) + servoPos, 0xFF);
}

#endif // __I2C_SERVOS__
