//#include "shared.h"
//#include "move.h"
//#include "relay.h"
//#include "lcd.h"
//#include "i2cManager.h"
//#include "init_hctl.h"
//#include "start_jack.h"
//#include "servo_control.h"

#include "robot.h"
#include "spline.h"

#define DEBUG_MODULE_NAME MAIN
#include "debug.h"

#define RELAY_MOTOR 1
#define RELAY_BASCULE 2
#define RELAY_CROCHET 0

unsigned char thetaSup(double x, double y, double theta, void* params)
{
  double thetaRef = *((double*)params);
  return theta > thetaRef;
}

int main()
{
  double i = 1.0;
  double j = 2.0;
  MovementDescriptor* move,*move2, *move3;
  WatchPoint* watchPoint1,*watchPoint2;
  Point* splinePoints;
  Point directionDepart, directionFin;

  debug_printf(DEBUG_MODULE_NAME,"Start soft\n");



  shared_initModule();

  i2c_initModule();

  printf("avant INIT\n");
  
  INIThctl();

  printf("apres INIT\n");

  move_initModule();

  

  
  /*
  startJackDetection();

  debug_printf(DEBUG_MODULE_NAME,"Wait jack off\n");
  waitJackOff();
  debug_printf(DEBUG_MODULE_NAME,"Wait jack on\n");
  waitJackOn();
  debug_printf(DEBUG_MODULE_NAME,"Wait jack off\n");
  waitJackOff();

  endJackDetection();
  */
  

  /*
  move = defineRotationMovement(3.1415);

  setMaxSpeed(move, 0.0 , 127.0 , MAX_SPEED_NOT_PROPORTIONAL);

  watchPoint1 = addWatchPoint(move,&thetaSup,&i);
  setPermanentWatchPoint(watchPoint1);
  watchPoint2 = addWatchPoint(move,&thetaSup,&j);
  startMove(move);

  debug_printf(DEBUG_MODULE_NAME,"Waiting theta>1\n");

  waitWatchPoint(watchPoint1);
  
  debug_printf(DEBUG_MODULE_NAME,"OK Theta>1\n");

  //  stopMove();

   debug_printf(DEBUG_MODULE_NAME,"Waiting theta>2\n");

  waitWatchPoint(watchPoint2);
  
  debug_printf(DEBUG_MODULE_NAME,"OK Theta>2\n");

  stopMove();

  sleep(1);
  */

  /*
  move2 = defineLinearMovement(1000.0);
  startMove(move2);

  sleep(30);
  */
  
  

  splinePoints = (Point*) malloc(11*sizeof(Point));
  splinePoints[0].x = 0.0;
  splinePoints[0].y = 0.0;
  splinePoints[1].x = 300.0;
  splinePoints[1].y = 0.0;
  splinePoints[2].x = 600.0;
  splinePoints[2].y = 300.0;
  splinePoints[3].x = 900.0;
  splinePoints[3].y = 600.0;
  splinePoints[4].x = 1800.0;
  splinePoints[4].y = 600.0;
  splinePoints[5].x = 1800.0;
  splinePoints[5].y = 300.0;
  splinePoints[6].x = 1800.0;
  splinePoints[6].y = 0.0;
  splinePoints[7].x = 1650.0;
  splinePoints[7].y = -100.0;
  splinePoints[8].x = 1500.0;
  splinePoints[8].y = -100.0;
  splinePoints[9].x = 1200.0;
  splinePoints[9].y = 50.0;
  splinePoints[10].x = 0.0;
  splinePoints[10].y = 0.0;

  directionDepart.x = 10;
  directionDepart.y = 10;
  directionFin.x = 10;
  directionFin.y = 10;
  
  printf("BEGIN of SCENARIO\n");

  move3 = defineSplineMovement(directionDepart, directionFin, splinePoints, 11);
  startMove(move3);

  sleep(50);

  debug_printf(DEBUG_MODULE_NAME,"END OF SCENARIO...\n");
//  while (1) { sleep(1); }

}
