//#include "mbuff.h"

#include <linux/cons.h>
#include <rtlinux/rtl_sched.h>

#include <sys/io.h>
#include <math.h>

#include "servos.h"
#include "servo_control.h"


//include <mbuff.h>

#include "shared.h"

//#include <shared_block.h>

//unsigned char ServoCons[NB_SERVO];

#define NANOPERIODSERVO 50000

#define LPT_PORT 0x378

//volatile Servos_Cons_T *servosCons;

static int currentStep = 0;

static float coeff = ( ((float)CMD_MAX - (float)CMD_MIN) / 255.0 );

static pthread_t fSer;


void set_pos_servo(int servoID, unsigned char pos)
{
  (globalState->ServosCons)[servoID] = pos;
}

void control_servo()
{
  int i;
  unsigned char controlValue = 0;
  
//  ServoCons[0]=0; 
//  ServoCons[1]=255;
//  ServoCons[2]=70;
//  ServoCons[3]=128;

  for (i=0 ; i < NB_SERVO ; i++)
    {
      if ( (float)currentStep < ( ( (globalState->ServosCons)[i]*coeff + CMD_MIN ) ) )
	controlValue = controlValue | (1<<i);
    }

  
//  controlValue = controlValue << OFFSET_CONTROL_REGISTER;

  //  if (controlValue != 0) 
  //  {
//      rtl_printf("%d %d %d %d\n", (*servosCons)[0],(*servosCons)[1],(*servosCons)[2],(*servosCons)[3]);
  //    rtl_printf("%d\n",controlValue);
      //  }

  outb(controlValue, LPT_PORT);

  if (currentStep>=LENGTH_CYCLE)
    currentStep=0;
  else
    currentStep++;  
}

void * Servo(void * junk)
{
  rtl_printf("Main servo loop launched\n");
  while (1)
    {
      pthread_wait_np();
      control_servo();
    }
}

void init_servos()
{
  struct sched_param params;
  int i;
  
  pthread_attr_t att;

  hrtime_t now;


//<<<<<<< servo_control.c
//  for (i=0 ; i< NB_SERVO ; i++)
//    {
//      (*servosCons)[i] = 255;
//    }

//=======
  (globalState->ServosCons)[0]=255; 
  (globalState->ServosCons)[1]=255;
  (globalState->ServosCons)[2]=70;
  (globalState->ServosCons)[3]=128;

//>>>>>>> 1.2
  pthread_attr_init (&att);

    if (pthread_create(&fSer, &att, Servo, NULL))
    {
      printk("pthread_create failed\n");
    }

  params.sched_priority = SERVOPRIORITY;

  pthread_setschedparam(fSer, 3, &params);

  pthread_setfp_np(fSer,1);

  now = gethrtime();

  pthread_make_periodic_np(fSer,now,NANOPERIODSERVO);
  
  printk("Servo loaded.\n");
  
}






void cleanup_servo(void)
{
  printk("Servo cleaned up.\n");

  pthread_delete_np(fSer);
  
  //  mbuff_free_patch(ServosConsAddr,(void*)servosCons);
}
