#ifndef __DEBUG_H__
#define __DEBUG_H__

#include <stdio.h>

#ifndef DEBUG_MODULE_NAME 
#error "You have to set the DEBUG_MODULE_NAME before including debug.h !!!"
#endif

#ifdef DEBUG
#define DEBUG_PRINTF(MODULE,...) do { \
                                      printf("[%s] [%s - line %d] "," " #MODULE " ", __FILE__, __LINE__); \
                                      printf(__VA_ARGS__); \
                                    } while (0)
#else
#define DEBUG_PRINTF(MODULE,...)
#endif

#define debug_printf(...) DEBUG_PRINTF(__VA_ARGS__)

#endif // __DEBUG_H__
