#ifndef __I2C_MAPPING_H__
#define __I2C_MAPPING_H__

#define NB_I2C_SLAVES 2

#define I2C_SLAVE_ADDRESS_1 0x26
#define I2C_SLAVE_ADDRESS_2 0x20

static unsigned char I2C_SLAVE_ADDRESS[NB_I2C_SLAVES] = {I2C_SLAVE_ADDRESS_1,
							 I2C_SLAVE_ADDRESS_2};

#define I2C_CARD_1_ID 0
#define I2C_CARD_2_ID 1

#define I2C_ARM_MOTOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_ARM_MOTOR_BIT 1

#define I2C_BIG_STAR_PMI_HOOK_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_BIG_STAR_PMI_HOOK_BIT 0

#define I2C_ARM_HOOK_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_ARM_HOOK_BIT 2

#define I2C_INITHCTL_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_INITHCTL_BIT 7

#define I2C_STARTJACK_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_STARTJACK_BIT 4 

#define I2C_ELECTRO_SLAVE I2C_SLAVE_ADDRESS_2

#define I2C_FRONT_BUMPER_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_FRONT_BUMPER_BIT 3
							 
#define I2C_LEFT_LINE_SENSOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_LEFT_LINE_SENSOR_BIT 5

#define I2C_RIGHT_LINE_SENSOR_SLAVE I2C_SLAVE_ADDRESS_1
#define I2C_RIGHT_LINE_SENSOR_BIT 6


#endif // __I2C_MAPPING_H__

